/*
 * Include File < axes.h >
 *
 * Draw Axes on View Port for Borland Graphics Interface
 *
 * Copyright (c) 1991-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _AXES_H_
#define _AXES_H_

/*
 * ӥ塼ݡȺɸϤΤκɸ롼
 *
 * 㤨СʲΤ褦˻Ȥ
 * 1) ˣټ񤭤
 *    drawaxisy( AXIS_LEFT,   Ĺʬ, ûʬ, Ĺ,  );
 *
 * 2) ˣؼ񤭤
 *    drawaxisx( AXIS_BOTTOM, Ĺʬ, ûʬ, Ĺ,  );
 *
 * 3) ˣؼ񤭤
 *    drawaxisx( AXIS_INSIDE, Ĺʬ, ûʬ, Ĺ, ֺɸ );
 */

enum axis_positions {
  AXIS_LEFT   = 0, /* ټ */
  AXIS_RIGHT  = 1, /* ټ */
  AXIS_TOP    = 0, /* ؼ */
  AXIS_BOTTOM = 1, /* ؼ */
  AXIS_INSIDE = 2, /* XY */
};

/*
 * ӥ塼ݡȤأؼ
 *
 * int apos ɸ֥
 * int sep  Ĺʬ
 * int ssep ûʬ
 * int len  Ĺ
 * int bos  ֥פ AXIS_INSIDE ʳξ硢ӥ塼ݡȤϤ
 *          ֥פ AXIS_INSIDE ξ硢褹ֺɸ
 */
void drawaxisx( int apos, int sep, int ssep, int len, int bos )
{
  float width, height;
  int i;
  struct viewporttype cv;
  
  getviewsettings( &cv );
  width  = cv.right  - cv.left + 1;
  height = cv.bottom - cv.top  + 1;
  switch ( apos ){
  case AXIS_TOP:
    height = 0; bos*=-1; len*=-1;
  case AXIS_BOTTOM:
    line( 0, height+bos+len, width/*-1*/, height+bos+len );
    break;
  case AXIS_INSIDE:
    height = 0;
    line( 0, height+bos, width/*-1*/, height+bos );
    break;
  }
  i = 0;
  while ( i<sep*ssep ){
    switch ( apos ){
    case AXIS_LEFT: case AXIS_RIGHT:
      line( width/(sep*ssep)*i, height+bos+len/2,
           width/(sep*ssep)*i, height+bos+len );
      break;
    case AXIS_INSIDE:
      line( width/(sep*ssep)*i, height+bos-len/4,
           width/(sep*ssep)*i, height+bos+len/4+1 );
      break;
    }
    i++;
  }
  i = 0;
  while ( i<sep ){
    switch ( apos ){
    case AXIS_LEFT: case AXIS_RIGHT:
      line( width/sep*i, height+bos, width/sep*i, height+bos+len );
      break;
    case AXIS_INSIDE:
      line( width/sep*i, height+bos-len/2, width/sep*i, height+bos+len/2+1 );
      break;
    }      
    i++;
  }
  switch ( apos ){
  case AXIS_LEFT: case AXIS_RIGHT:
    line( width/sep*i-1, height+bos, width/sep*i-1, height+bos+len );
    break;
  case AXIS_INSIDE:
    line( width/sep*i-1, height+bos-len/2, width/sep*i-1, height+bos+len/2+1 );
    break;
  }
}

/*
 * ӥ塼ݡȤأټ
 *
 * int apos ɸ֥
 * int sep  Ĺʬ
 * int ssep ûʬ
 * int len  Ĺ
 * int bos  ֥פ AXIS_INSIDE ʳξ硢ӥ塼ݡȤϤ
 *          ֥פ AXIS_INSIDE ξ硢褹ֺɸ
 */
void drawaxisy( int apos, int sep, int ssep, int len, int bos )
{
  float width, height;
  int i;
  struct viewporttype cv;

  getviewsettings( &cv );
  width  = cv.right  - cv.left + 1;
  height = cv.bottom - cv.top  + 1;
  switch ( apos ){
  case AXIS_LEFT:
    width = 0; bos*=-1; len*=-1;
  case AXIS_RIGHT:
    line( width+bos+len, 0, width+bos+len, height/*-1*/ );
    break;
  case AXIS_INSIDE:
    width = 0;
    line( width+bos, 0, width+bos, height/*-1*/ );
    break;
  }
  i = 0;
  while ( i<sep*ssep ){
    switch ( apos ){
    case AXIS_LEFT: case AXIS_RIGHT:
      line( width+bos+len/2, height/(sep*ssep)*i,
           width+bos+len, height/(sep*ssep)*i );
      break;
    case AXIS_INSIDE:
      line( width+bos-len/4, height/(sep*ssep)*i,
           width+bos+len/4+1, height/(sep*ssep)*i );
      break;
    }
    i++;
  }
  i = 0;
  while ( i<sep ){
    switch ( apos ){
    case AXIS_LEFT: case AXIS_RIGHT:
      line( width+bos, height/sep*i, width+bos+len, height/sep*i );
      break;
    case AXIS_INSIDE:
      line( width+bos-len/2, height/sep*i, width+bos+len/2+1, height/sep*i );
      break;
    }
    i++;
  }
  switch ( apos ){
  case AXIS_LEFT: case AXIS_RIGHT:
    line( width+bos, height/sep*i-1, width+bos+len, height/sep*i-1 );
    break;
  case AXIS_INSIDE:
    line( width+bos-len/2, height/sep*i-1, width+bos+len/2+1, height/sep*i-1 );
    break;
  }
}

/*
 * ɸδʰץޥ
 *
 * drawaxisl  ټ
 * drawaxist  ؼ
 * drawaxisr  ټ
 * drawaxisb  ؼ
 * drawaxislb ټȲؼ
 * 
 * drawxisix  ؼ
 * drawxisiy  ټ
 * drawxisi   أټ
 */
#define drawaxisl(s,ss,l,b) drawaxisy(AXIS_LEFT,  s,ss,l,b)
#define drawaxist(s,ss,l,b) drawaxisx(AXIS_TOP,   s,ss,l,b)
#define drawaxisr(s,ss,l,b) drawaxisy(AXIS_RIGHT, s,ss,l,b)
#define drawaxisb(s,ss,l,b) drawaxisx(AXIS_BOTTOM,s,ss,l,b)
#define drawaxeslb(sx,ssx,sy,ssy,l,b) do{\
        drawaxisl(sx,ssx,l,b);drawaxisb(sy,ssy,l,b);}while(0)

#define drawaxisix(s,ss,l,b) drawaxisx(AXIS_INSIDE,s,ss,l,b)
#define drawaxisiy(s,ss,l,b) drawaxisy(AXIS_INSIDE,s,ss,l,b)
#define drawaxesi(sx,ssx,sy,ssy,l,bx,by) do{\
        drawaxisix(sx,ssx,l,bx);drawaxisiy(sy,ssy,l,by);}while(0)

#endif
