/*
 * test of graphXX_.h
 */
#include <malloc.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <graphr3_.h>
#include <graphp3_.h>
#include <graphs3_.h>
#include <graphr4_.h>
#include <graphp4_.h>
#include <graphs4_.h>
#ifdef __MSDOS__
#  include <xbgi2bgi.h>
#endif
#ifndef _XBGI_
#  define PATHDRIVER "c:/borlandc/bgi"
#else
#  define PATHDRIVER "-geometry 720x720"
#endif

enum graphcoodstype { /* ɸϥ */
  ROTATION,     /* žѴɸ */
  PERSPECTIVE,  /* ƩѴɸ */
  COLOR_GLASS,  /* ƥ쥪 */
  DOUBLE_IMAGE, /* ƥ쥪 */
  N_COODS
};
enum graphobject { /* ʪ */
  CUBE,      /* 磻䡼ե졼Ω */
  BOX,       /* եΩ */
  HYPERCUBE, /* ĶΩ */
  N_OBJECT
};
struct graphcoodssettype { /* ɸ꽸 */
  int coods;               /* ɸ */
  int dim;                 /*  */
  struct rotationport {    /* ž */
    double xf, yf, zf, wf;
    double xt, yt, zt, wt;
  } rp;
  int rotx, roty, rotz;    /* ž */
  double mag;              /* Ψ */
  double x, y;             /* ʿ԰ư */
  double dst;              /* ƩѴΥ */
  double stereo_dst;       /* ƥ쥪ξΥ */
  int stereo_w;            /* ƥ쥪ξ */
  int rotwx, rotwy, rotwz; /* ž */
  double hyper_mag;        /* Ψ */
  int moving;              /* ּ */
  int object;              /* ʪ */
} coods, coods0;
#define c coods
/* ɤˤɸ꽸 */
int graphcoodsbykey( int key )
{
  int redraw = !0;

  coods0 = coods;
  switch ( key ){
  /*  */
  case '!':
    c.coods = ROTATION;
    c.dim = 3;
    c.rp.xf = 0.0; c.rp.yf = 0.0; c.rp.zf = 0.0; c.rp.wf = 0.0;
    c.rp.xt = 1.0; c.rp.yt = 1.0; c.rp.zt = 1.0; c.rp.wt = 1.0;
    c.rotx = -15; c.roty = 10; c.rotz = 0;
    c.mag = 1.0;
    c.x = 0.0; c.y = 0.0;
    c.dst = 0.5;
    c.stereo_dst = 0.5;
    c.stereo_w = 150;
    c.rotwx = 0; c.rotwy = 0; c.rotwz = 0;
    c.hyper_mag = 1.0;
    c.moving = 0;
    c.object = CUBE;
  /*  */
  case 'r': break;
  /* ž */
  case '2': c.rotx -= 5; c.rotx = (c.rotx+360)%360; break;
  case '8': c.rotx += 5; c.rotx = (c.rotx+360)%360; break;
  case '4': c.roty += 5; c.roty = (c.roty+360)%360; break;
  case '6': c.roty -= 5; c.roty = (c.roty+360)%360; break;
  case '-': c.rotz -= 5; c.rotz = (c.rotz+360)%360; break;
  case '+': c.rotz += 5; c.rotz = (c.rotz+360)%360; break;
  case '/': c.rotwx -= 5; c.rotwx = (c.rotwx+360)%360; break;
  case '*': c.rotwx += 5; c.rotwx = (c.rotwx+360)%360; break;
  case '[': c.rotwy -= 5; c.rotwy = (c.rotwy+360)%360; break;
  case ']': c.rotwy += 5; c.rotwy = (c.rotwy+360)%360; break;
  case '{': c.rotwz -= 5; c.rotwz = (c.rotwz+360)%360; break;
  case '}': c.rotwz += 5; c.rotwz = (c.rotwz+360)%360; break;
  case '5': c.rotx=c.roty=c.rotz=c.rotwx=c.rotwy=c.rotwz = 0.0; break;
  /* ʿ԰ư */
  case 'x': c.y -= 0.05; break;
  case 'e': c.y += 0.05; break;
  case 's': c.x -= 0.05; break;
  case 'd': c.x += 0.05; break;
  case 'c': c.x = c.y = 0.0; break;
  /* ̾⤷ϻΥư */
  case 'f': if (c.coods==ROTATION) c.mag *= 1.1; else c.dst *= 0.9; break;
  case 'b': if (c.coods==ROTATION) c.mag *= 0.9; else c.dst *= 1.1; break;
  case 'g': if (c.coods==ROTATION) c.mag  = 1.0; else c.dst  = 0.5; break;
  case '(': c.stereo_dst *= 0.9; break;
  case ')': c.stereo_dst *= 1.1; break;
  case '0': c.stereo_dst  = 0.5; break;
  case '<': c.stereo_w -= 10; break;
  case '>': c.stereo_w += 10; break;
  case '.': c.stereo_w =  150; break;
  case ',': c.stereo_w = -150; break;
  /* ¾ */
  case 'T':
    c.coods = (c.coods+1)%N_COODS;
    break;
  case 'M':
    c.moving = !c.moving;
    break;
  case 'O':
    c.object = (c.object+1)%N_OBJECT;
    if ( c.object == HYPERCUBE )
      coods.dim = 4;
    else
      coods.dim = 3;
    break;
  default: redraw = 0;
  }
  return redraw;
}
/* ɸ꽸 */
void setgraphcoods( void )
{
  setmagnify_( c.mag );
  setrotationport_( c.rp.xf, c.rp.yf, c.rp.zf, c.rp.xt, c.rp.yt, c.rp.zt );
  setrotation_( M_PI/180*c.rotx, M_PI/180*c.roty, M_PI/180*c.rotz );
  setwindow_( -1.0/c.mag-c.x, 1.0/c.mag-c.y, 1.0/c.mag-c.x, -1.0/c.mag-c.y );
  setdistance_( c.dst );
  stereodistance_( c.stereo_dst );
  stereowidthimages( c.stereo_w );
  setcolor( getmaxcolor() );
  if ( c.coods == COLOR_GLASS  ) setstereotype( ColorGlass  );
  if ( c.coods == DOUBLE_IMAGE ) setstereotype( DoubleImage );
  if ( c.dim == 4 ){
    hypermagnify_( c.hyper_mag );
    hyperrotation_( M_PI/180*c.rotwx, M_PI/180*c.rotwy, M_PI/180*c.rotwz );
    hyperrotationport_( c.rp.xf, c.rp.yf, c.rp.zf, c.rp.wf,
                        c.rp.xt, c.rp.yt, c.rp.zt, c.rp.wt );
  }
}
#undef c
/*  */
void draw( void )
{
  switch ( coods.object ){
  case CUBE:
    switch( coods.coods ){
    case ROTATION:     cuber3_( 1, 1, 1, 0, 0, 0, !0 ); break;
    case PERSPECTIVE:  cubep3_( 1, 1, 1, 0, 0, 0,  0 ); break;
    case COLOR_GLASS:
    case DOUBLE_IMAGE: cubes3_( 1, 1, 1, 0, 0, 0,  0 ); break;
    }
    break;
  case BOX:
    switch( coods.coods ){
    case ROTATION:     boxr3_( 1, 1, 1, 0, 0, 0, NULL ); break;
    case PERSPECTIVE:  boxp3_( 1, 1, 1, 0, 0, 0, NULL ); break;
    case COLOR_GLASS:
    case DOUBLE_IMAGE: boxs3_( 1, 1, 1, 0, 0, 0, NULL ); break;
    }
    break;
  case HYPERCUBE:
    switch( coods.coods ){
    case ROTATION:     cuber4_( 1, 1, 1, 1, 0, 0, 0, 0, !0 ); break;
    case PERSPECTIVE:  cubep4_( 1, 1, 1, 1, 0, 0, 0, 0, !0 ); break;
    case COLOR_GLASS:
    case DOUBLE_IMAGE: cubes4_( 1, 1, 1, 1, 0, 0, 0, 0, !0 ); break;
    }
    break;
  }
}
/* õ */
void delete( void )
{
  xsync();
  switch ( coods0.object ){
  case CUBE:
    switch( coods0.coods ){
    case ROTATION:     cuber3_( 1, 1, 1, 0, 0, 0, !0 ); break;
    case PERSPECTIVE:  cubep3_( 1, 1, 1, 0, 0, 0,  0 ); break;
    case COLOR_GLASS:
    case DOUBLE_IMAGE: cubes3_( 1, 1, 1, 0, 0, 0,  0 ); break;
    }
    break;
  case BOX:
    clearviewport();
    break;
  case HYPERCUBE:
    switch( coods0.coods ){
    case ROTATION:     cuber4_( 1, 1, 1, 1, 0, 0, 0, 0, !0 ); break;
    case PERSPECTIVE:  cubep4_( 1, 1, 1, 1, 0, 0, 0, 0, !0 ); break;
    case COLOR_GLASS:
    case DOUBLE_IMAGE: cubes4_( 1, 1, 1, 1, 0, 0, 0, 0, !0 ); break;
    }
    break;
  }
}
/* ᥤ */
int WIDTH, HEIGHT;
void main( void )
{
  int i, j;
  int gd = DETECT, gm, key;

  initgraph_( &gd, &gm, PATHDRIVER );
  WIDTH = HEIGHT = min( getmaxx()+1, getmaxy()+1 ) - 20;
  setviewport_( 10, 10, WIDTH+10, HEIGHT+10, !0 );
  setfillstyle( SOLID_FILL, LIGHTBLUE );
  setcolor( getmaxcolor() );
  setbkcolor( 0 );
  setwritemode( XOR_PUT );
  xsync();
  key = '!';
  do {
    if ( graphcoodsbykey( key ) ){
      delete();
      setgraphcoods();
      draw();
    }
    if ( kbhit() )
      key = getch();
    else
      if ( coods.moving ){
        if ( coods.object != HYPERCUBE ){
          graphcoodsbykey( '8' ); graphcoodsbykey( '6' );
        }else{
          graphcoodsbykey( '/' ); graphcoodsbykey( '{' );
        }
        key = 'r';
      }else
        key = getch();
  } while ( key != 0x1b );
  closegraph_();
  exit( 0 );
}
