/*
 * Include File < graphp3_.h >
 *
 * Perspective Translation on 3-dimensional Rotation Port for BGI
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHP3__H_
#define _GRAPHP3__H_
#include <graphr3_.h>

/*
  3ƩѴ(3-dimensional Perspective Translation)ѥå
  
  3βžɸϤɺɸϤѴ, ƩѴˤä
  ΥˤʪΤαᴶɽѥåǤ.
  Υѥå3Ѵѥå(graphr3_.h)ưޤ.
  ˤ򺮺ߤƻѤǤΤ, 󥿥饯ƥ֤˻Ѵ,ƩѴ
  ڤؤ뤳ȤǽǤ.
  
  ѻԤλΥꤹˤsetdistance_( d )Ȥޤ.
  Υdͤμ¿Ǥ. ͤꤹȽĲȿžƤޤޤ.
  ޤΥdǤ뤳ȤϻʪΤƱɸˤ뤳Ȥˤʤ,
  ͷ׻ǤϥСեˤʤäƤޤΤդƤ.

  㤨Хǥץ쥤˲ۤľ(X:0..1,Y:0..2,Z:0..3)Υ0.5
  ƩѴɽΤǤаʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );   ̤100x100ΰȤ
    setmagnify_( 1.5 );                   ƤȤγΨ
    setrotationport_( 0, 0, 0, 1, 2, 3 ); ˾βžɸϤ
    setrotation( RAD(-15), RAD(20), 0 );  žѤ
    setdistance_( 0.5 );                  Υ
    cubep3_( 0, 0, 0, 1, 2, 3, !0 );      žɸϤƱľΤ
 */

static double _PV = 1.0;
static double _P3TH = 2.5;
/*
 * macros for P3 space to R2 space
 */
#define p3tox(x,y,z) (r3tox(x,y,z)*_PV/(r3toz(x,y,z)+_P3TH))
#define p3toy(x,y,z) (r3toy(x,y,z)*_PV/(r3toz(x,y,z)+_P3TH))
#define p3toz(x,y,z) (_PV*(2.0-_PV/(r3toz(x,y,z)+_P3TH)))

#ifdef __MSDOS__
double (p3tox)(double x,double y,double z){return p3tox(x,y,z);}
double (p3toy)(double x,double y,double z){return p3toy(x,y,z);}
double (p3toz)(double x,double y,double z){return p3toz(x,y,z);}
#undef p3tox
#undef p3toy
#undef p3toz
#endif

/*
 * mocros to draw on window port
 */
#define linep3_(x1,y1,z1,x2,y2,z2) \
                             line_(p3tox(x1,y1,z1),p3toy(x1,y1,z1), \
                                   p3tox(x2,y2,z2),p3toy(x2,y2,z2))
#define linetop3_(x,y,z)     lineto_(p3tox(x,y,z),p3toy(x,y,z))
#define putpixelp3_(x,y,z,c) putpixel_(p3tox(x,y,z),p3toy(x,y,z),c)
#define movetop3_(x,y,z)     moveto_(p3tox(x,y,z),p3toy(x,y,z))
#define outtextxyp3_(x,y,z,str) \
                             outtextxy_(p3tox(x,y,z),p3toy(x,y,z),str)
/*
 * set current distance of viewpoint
 */
static void setdistance_( double d )
{
  _PV = 1.0/d;
}
/*
 * set current deformation parameter
 */
static void setdeformation_( double d )
{
  _P3TH = d;
}
/*
 * function to draw cubic
 */
static void cubep3_( double xf, double yf, double zf,
                    double xt, double yt, double zt, int flg )
{
  int i, maxi;
  double x0, y0, z0, x1, y1, z1, maxz, z;
  static int l[12][2] = {
    { 0, 1 }, { 0, 2 }, { 0, 4 },
    { 1, 3 }, { 1, 5 },
    { 2, 3 },
    { 5, 4 },
    { 6, 4 }, { 6, 2 },
    { 7, 6 }, { 7, 5 }, { 7, 3 }, 
  };
  struct linesettingstype ls;

  getlinesettings( &ls );
  maxz = p3toz( xf, yf, zf );
  maxi = 0;
  for ( i=1; i<8; i++ ){
    x0 = (i/1%2)?xt:xf;
    y0 = (i/2%2)?yt:yf;
    z0 = (i/4%2)?zt:zf;
    z = p3toz( x0, y0, z0 );
    if ( z>maxz ){
      maxz = z;
      maxi = i;
    }
  }
  for ( i=0; i<12; i++ ){
    x0 = (l[i][0]/1%2)?xt:xf; x1 = (l[i][1]/1%2)?xt:xf;
    y0 = (l[i][0]/2%2)?yt:yf; y1 = (l[i][1]/2%2)?yt:yf;
    z0 = (l[i][0]/4%2)?zt:zf; z1 = (l[i][1]/4%2)?zt:zf;
    if ( flg && ( l[i][0]==maxi || l[i][1]==maxi ) )
      setlinestyle( DOTTED_LINE, 0, NORM_WIDTH );
    else
      setlinestyle( SOLID_LINE, 0, NORM_WIDTH );
    linep3_( x0, y0, z0, x1, y1, z1 );
  }
  setlinestyle( ls.linestyle, ls.upattern, ls.thickness );
}
/*
 * function to draw box
 */
static void boxp3_( double xf, double yf, double zf, double xt,
                   double yt, double zt, int c6[] )
{
  int i, j, fil[6];
  double x, y, z, xy[5*2], xyz[3][3], A[3], B[3];
  static int s[6][5] = {
    { 0, 1, 3, 2, 0 },
    { 0, 2, 6, 4, 0 },
    { 0, 4, 5, 1, 0 },
    { 1, 5, 7, 3, 1 },
    { 3, 7, 6, 2, 3 },
    { 4, 6, 7, 5, 4 },
  };
  struct fillsettingstype fs;
  
  getfillsettings( &fs );
  for ( i=0; i<6; i++ ){
    for ( j=0; j<3; j++ ){
      x = p3tox((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
      y = p3toy((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
      z = p3toz((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
      xyz[j][0] = x;
      xyz[j][1] = y;
      xyz[j][2] = z;
    }
    A[0] = xyz[1][0] - xyz[0][0];
    A[1] = xyz[1][1] - xyz[0][1];
    /*A[2] = xyz[1][2] - xyz[0][2];*/
    B[0] = xyz[2][0] - xyz[1][0];
    B[1] = xyz[2][1] - xyz[1][1];
    /*B[2] = xyz[2][2] - xyz[1][2];*/
    fil[i] = A[0]*B[1]-A[1]*B[0]<0;
  }
  for ( i=0; i<6; i++ ){
    if ( fil[i] ){
      for ( j=0; j<5; j++ ){
        x = p3tox((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        y = p3toy((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        z = p3toz((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        xy[2*j+0] = x;
        xy[2*j+1] = y;
      }
      setfillstyle( fs.pattern, c6?c6[i]:fs.color );
      fillpoly_( 4, xy );
    }
  }
  setfillstyle( fs.pattern, fs.color );
}
/*
 * function to draw left hand
 */
static void lefthandp3_( double xf, double yf, double zf,
                        double xt, double yt, double zt, int flg )
{
  double borderx = (xt-xf)*0.1, bordery = (yt-yf)*0.1, borderz = (zt-zf)*0.1;

  linep3_( xf-borderx, yf-bordery, zf-borderz,
           xf+borderx, yf-bordery, zf-borderz );
  linep3_( xf-borderx, yf-bordery, zf-borderz,
           xf-borderx, yf+bordery, zf-borderz );
  linep3_( xf-borderx, yf-bordery, zf-borderz,
           xf-borderx, yf-bordery, zf+borderz );
  if ( flg ){
    outtextxyp3_( xf+borderx, yf-bordery, zf-borderz, "x" );
    outtextxyp3_( xf-borderx, yf+bordery, zf-borderz, "y" );
    outtextxyp3_( xf-borderx, yf-bordery, zf+borderz, "z" );
  }
}
#endif
