/*
 * Include File < graphr3_.h >
 *
 * 3-dimensional Rotation Port for Borland Graphic Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHR3__H_
#define _GRAPHR3__H_
#include <graphr2_.h>
#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

/*
  3Ѵ(3-dimensional Rotation Port Translation)ѥå
  
  3βžɸϤɺɸϤѴ, ɥѴѥå
  ǸƤӽФȤˤäƥǥץ쥤3֤ʿƩɽ뤿
  ѥåǤ. ʪΤ˱ᴶƩѴԤȤ,
  ΥѥåǤϤʤƩѴѥågraphp3_.hȤɬפޤ.
  
  ΥѥåŪǤդ3֤ǥץ쥤Ƥ뤳ȤǤ.
  Ǥդ3֤ǤΤǤΩΤǤɬפϤޤ.
  Ǽ¿3֤žɸ(Rotation Port)ȸƤӤޤ.
  ΥѥåǤϤβžɸϤƼʬ˲žѴܤ
  ɺɸϤΩΤȤƤޤ.
  㤨Хǥץ쥤˲ۤľ(X:0..1,Y:0..2,Z:0..3)ˤ
  ʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );   ̤100x100ΰȤ
    setmagnify_( 1.5 );                   ƤȤγΨ
    setrotationport_( 0, 0, 0, 1, 2, 3 ); ˾βžɸϤ
    setrotation_( RAD(-15), RAD(20), 0 ); žѤ
    cuber3_( 0, 0, 0, 1, 2, 3, !0 );      žɸϤƱľΤ

  setviewport_ˤƲĤޤʤ褦ΰꤷޤ.
  褷ľΤžsetrotationٻꤷ,
  cuber3_褹뤳Ȥˤä̤βžѤľΤȤǤޤ.
  ʤߤRADϥǥ꡼饸ѴޥǤ.
 */

static double _RCA, _RSA;
static double _RCB, _RSB;
static double _RCC, _RSC;
static double _R0X = 0.0, _R0Y = 0.0, _R0Z = 0.0;
static double _RFX = 1.0, _RFY = 1.0, _RFZ = 1.0;
static double _RM = 1.4;
/*
 * macros for R3 space to R2 space
 */
static double _R11 = 1.0, _R12 = 0.0, _R13 = 0.0;
static double _R21 = 0.0, _R22 = 1.0, _R23 = 0.0;
static double _R31 = 0.0, _R32 = 0.0, _R33 = 1.0;
#define r3tox(x,y,z) (_RFX*((x)-_R0X)*_R11\
                     +_RFY*((y)-_R0Y)*_R21\
                     +_RFZ*((z)-_R0Z)*_R31)
#define r3toy(x,y,z) (_RFX*((x)-_R0X)*_R12\
                     +_RFY*((y)-_R0Y)*_R22\
                     +_RFZ*((z)-_R0Z)*_R32)
#define r3toz(x,y,z) (_RFX*((x)-_R0X)*_R13\
                     +_RFY*((y)-_R0Y)*_R23\
                     +_RFZ*((z)-_R0Z)*_R33)
/*
 * mocros to draw on window port
 */
#define liner3_(x1,y1,z1,x2,y2,z2) \
                             line_(r3tox(x1,y1,z1),r3toy(x1,y1,z1),\
                                   r3tox(x2,y2,z2),r3toy(x2,y2,z2))
#define linetor3_(x,y,z)     lineto_(r3tox(x,y,z),r3toy(x,y,z))
#define putpixelr3_(x,y,z,c) putpixel_(r3tox(x,y,z),r3toy(x,y,z),c)
#define movetor3_(x,y,z)     moveto_(r3tox(x,y,z),r3toy(x,y,z))
#define outtextxyr3_(x,y,z,str) \
                             outtextxy_(r3tox(x,y,z),r3toy(x,y,z),str)
/*
 * set current rotation port
 */
static void setrotationport_( double xf, double yf, double zf,
                             double xt, double yt, double zt )
{
  _R0X = (xf+xt)/2;   _R0Y = (yf+yt)/2;   _R0Z = (zf+zt)/2;
  _RFX = 1.0/(xt-xf); _RFY = 1.0/(yt-yf); _RFZ = 1.0/(zt-zf);
}
/*
 * set magnify to rotation port
 */
static void setmagnify_( double rm )
{
  _RM = rm;
  setwindow_( -1.0/_RM, -1.0/_RM, 1.0/_RM, 1.0/_RM );
}
/*
 * set rotation angle
 */
static void setrotation_( double a, double b, double c )
{
  _RCA = cos(a); _RSA = sin(a);
  _RCB = cos(b); _RSB = sin(b);
  _RCC = cos(c); _RSC = sin(c);
  _R11=_RCB*_RCC-_RSB*_RSA*_RSC;_R12=_RCB*_RSC+_RSB*_RSA*_RCC;_R13=-_RSB*_RCA;
  _R21=         -     _RCA*_RSC;_R22=               _RCA*_RCC;_R23=      _RSA;
  _R31=_RSB*_RCC+_RCB*_RSA*_RSC;_R32=_RSB*_RSC-_RCB*_RSA*_RCC;_R33= _RCB*_RCA;
}
/*
 * function to draw cubic
 */
static void cuber3_( double xf, double yf, double zf,
                    double xt, double yt, double zt, int flg )
{
  int i, maxi;
  double x0, y0, z0, x1, y1, z1, maxz, z;
  static int l[12][2] = {
    { 0, 1 }, { 0, 2 }, { 0, 4 },
    { 1, 3 }, { 1, 5 },
    { 2, 3 },
    { 5, 4 },
    { 6, 4 }, { 6, 2 },
    { 7, 6 }, { 7, 5 }, { 7, 3 }, 
  };
  struct linesettingstype ls;

  getlinesettings( &ls );
  maxz = r3toz( xf, yf, zf );
  maxi = 0;
  for ( i=1; i<8; i++ ){
    x0 = (i/1%2)?xt:xf;
    y0 = (i/2%2)?yt:yf;
    z0 = (i/4%2)?zt:zf;
    z = r3toz( x0, y0, z0 );
    if ( z>maxz ){
      maxz = z;
      maxi = i;
    }
  }
  for ( i=0; i<12; i++ ){
    x0 = (l[i][0]/1%2)?xt:xf; x1 = (l[i][1]/1%2)?xt:xf;
    y0 = (l[i][0]/2%2)?yt:yf; y1 = (l[i][1]/2%2)?yt:yf;
    z0 = (l[i][0]/4%2)?zt:zf; z1 = (l[i][1]/4%2)?zt:zf;
    if ( flg && ( l[i][0]==maxi || l[i][1]==maxi ) )
      setlinestyle( DOTTED_LINE, 0, NORM_WIDTH );
    else
      setlinestyle( SOLID_LINE, 0, NORM_WIDTH );
    liner3_( x0, y0, z0, x1, y1, z1 );
  }
  setlinestyle( ls.linestyle, ls.upattern, ls.thickness );
}
/*
 * function to draw box
 */
static void boxr3_( double xf, double yf, double zf,
                   double xt, double yt, double zt, int c6[] )
{
  int i, j, mini, fil;
  double x, y, z, xy[5*2], minz;
  static int s[6][5] = {
    { 0, 1, 3, 2, 0 },
    { 0, 2, 6, 4, 0 },
    { 0, 4, 5, 1, 0 },
    { 1, 5, 7, 3, 1 },
    { 3, 7, 6, 2, 3 },
    { 4, 6, 7, 5, 4 },
  };
  struct fillsettingstype fs;

  getfillsettings( &fs );
  minz = r3toz( xf, yf, zf );
  mini = 0;
  for ( i=1; i<8; i++ ){
    z = r3toz((i/1%2)?xt:xf,(i/2%2)?yt:yf,(i/4%2)?zt:zf);
    if ( z<minz ){
      minz = z;
      mini = i;
    }
  }
  for ( i=0; i<6; i++ ){
    fil = 0;
    for ( j=0; j<5; j++ )
      if ( s[i][j]==mini )
        fil = !0;
    if ( fil ){
      for ( j=0; j<5; j++ ){
        x = r3tox((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        y = r3toy((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        xy[2*j+0] = x;
        xy[2*j+1] = y;
      }
      setfillstyle( SOLID_FILL, c6?c6[i]:fs.color );
      fillpoly_( 4, xy );
    }
  }
  setfillstyle( fs.pattern, fs.color );
}
/*
 * function to draw left hand
 */
static void lefthandr3_( double xf, double yf, double zf,
                        double xt, double yt, double zt, int flg )
{
  double borderx = (xt-xf)*0.1, bordery = (yt-yf)*0.1, borderz = (zt-zf)*0.1;

  liner3_( xf-borderx, yf-bordery, zf-borderz,
           xf+borderx, yf-bordery, zf-borderz );
  liner3_( xf-borderx, yf-bordery, zf-borderz,
           xf-borderx, yf+bordery, zf-borderz );
  liner3_( xf-borderx, yf-bordery, zf-borderz,
           xf-borderx, yf-bordery, zf+borderz );
  if ( flg ){
    outtextxyr3_( xf+borderx, yf-bordery, zf-borderz, "x" );
    outtextxyr3_( xf-borderx, yf+bordery, zf-borderz, "y" );
    outtextxyr3_( xf-borderx, yf-bordery, zf+borderz, "z" );
  }
}
#endif
