/*
 * Include File < graphr4_.h >
 *
 * 4-Dimensional Rotation Port for Borland Graphic Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHR4__H_
#define _GRAPHR4__H_
#include <graphr3_.h>
#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

/*
  4Ѵ(4-dimensional Rotation Port Translation)ѥå
  
  4βžɸϤ3ɸϤѴ, 3Ѵѥå
  ǸƤӽФȤˤäƥǥץ쥤4֤ʿƩɽ뤿
  ѥåǤ. ʪΤ˱ᴶƩѴԤȤ,
  ΥѥåǤϤʤƩѴѥågraphp4_.hȤɬפޤ.
  
  ΥѥåŪǤդ4֤ǥץ쥤Ƥ뤳ȤǤ.
  Ǥդ4֤ǤΤǤΩΤǤɬפϤޤ.
  Ǽ¿4֤Ķžɸ(Hyper Rotation Port)ȸƤӤޤ.
  ΥѥåǤϤβžɸϤƼʬ˲žѴܤ
  3ɸϤĶΩΤȤƤޤ.
  㤨Хǥץ쥤˲ۤĶľ(X:0..1,Y:0..2,Z:0..3,W:0..4)ˤ
  ʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );           ̤100x100ΰȤ
    hypermagnify_( 1.5 );                         ƤȤγΨ
    hyperrotationport_( 0, 0, 0, 0, 1, 2, 3, 4 ); ˾βžɸϤ
    setrotation_( RAD(-15), RAD(20), 0 );         žѤ(X,Y,Z)
    hyperrotation_( RAD(-15), RAD(45), 0 );       žѤ(XW,YW,ZW)
    cuber4_( 0, 0, 0, 0, 1, 2, 3, 4, !0 );        žɸϤƱľΤ

  褷ĶľΤžhyperrotationٻꤷ,
  cuber4_褹뤳Ȥˤä̤βžѤĶľΤȤǤޤ.
  ʤߤRADϥǥ꡼饸ѴޥǤ.
 */

static double _HCD, _HSD;
static double _HCE, _HSE;
static double _HCF, _HSF;
static double _H0X = 0.0, _H0Y = 0.0, _H0Z = 0.0, _H0W = 0.0;
static double _HFX = 1.0, _HFY = 1.0, _HFZ = 1.0, _HFW = 1.0;
static double _HM = 1.4;
/*
 * macros for R4 space to R3 space
 */
static double _H11, _H12, _H13, _H14;
static double _H21, _H22, _H23, _H24;
static double _H31, _H32, _H33, _H34;
static double _H41, _H42, _H43, _H44;
#define r4tox(x,y,z,w) (_HFX*((x)-_H0X)*_H11 \
                       +_HFY*((y)-_H0Y)*_H21 \
                       +_HFZ*((z)-_H0Z)*_H31 \
                       +_HFW*((w)-_H0W)*_H41)
#define r4toy(x,y,z,w) (_HFX*((x)-_H0X)*_H12 \
                       +_HFY*((y)-_H0Y)*_H22 \
                       +_HFZ*((z)-_H0Z)*_H32 \
                       +_HFW*((w)-_H0W)*_H42)
#define r4toz(x,y,z,w) (_HFX*((x)-_H0X)*_H13 \
                       +_HFY*((y)-_H0Y)*_H23 \
                       +_HFZ*((z)-_H0Z)*_H33 \
                       +_HFW*((w)-_H0W)*_H43)
#define r4tow(x,y,z,w) (_HFX*((x)-_H0X)*_H14 \
                       +_HFY*((y)-_H0Y)*_H24 \
                       +_HFZ*((z)-_H0Z)*_H34 \
                       +_HFW*((w)-_H0W)*_H44)
#ifdef __MSDOS__
double (r4tox)(double x,double y,double z,double w){return r4tox(x,y,z,w);}
double (r4toy)(double x,double y,double z,double w){return r4toy(x,y,z,w);}
double (r4toz)(double x,double y,double z,double w){return r4toz(x,y,z,w);}
double (r4tow)(double x,double y,double z,double w){return r4tow(x,y,z,w);}
#undef r4tox
#undef r4toy
#undef r4toz
#undef r4tow
#endif
/*
 * mocros to draw on window port
 */
#define liner4_(x1,y1,z1,w1,x2,y2,z2,w2) \
             liner3_(r4tox(x1,y1,z1,w1),r4toy(x1,y1,z1,w1),r4toz(x1,y1,z1,w1),\
                     r4tox(x2,y2,z2,w2),r4toy(x2,y2,z2,w2),r4toz(x2,y2,z2,w2))
#define linetor4_(x,y,z,w) \
                        linetor3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toz(x,y,z,w))
#define putpixelr4_(x,y,z,w,c) \
                    putpixelr3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toz(x,y,z,w),c)
#define movetor4_(x,y,z,w) \
                        movetor3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toz(x,y,z,w))
#define outtextxyr4_(x,y,z,w,str) \
                 outtextxyr3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toy(x,y,z,w),str)
/*
 * set current hyper rotation port
 */
static void hyperrotationport_( double xf, double yf, double zf, double wf,
                                double xt, double yt, double zt, double wt )
{
  _H0X=(xf+xt)/2;   _H0Y=(yf+yt)/2;   _H0Z=(zf+zt)/2;   _H0W=(wf+wt)/2;
  _HFX=1.0/(xt-xf); _HFY=1.0/(yt-yf); _HFZ=1.0/(zt-zf); _HFW=1.0/(wt-wf);
}
/*
 * set magnify to hyper rotation port
 */
static void hypermagnify_( double hm )
{
  _HM = hm;
  setrotationport_( -0.5/_HM, -0.5/_HM, -0.5/_HM, 0.5/_HM, 0.5/_HM, 0.5/_HM );
}
/*
 * set rotation angle
 */
static void hyperrotation_( double d, double e, double f )
{
  _HCD = cos(d); _HSD = sin(d);
  _HCE = cos(e); _HSE = sin(e);
  _HCF = cos(f); _HSF = sin(f);
  _H11= _HCD;_H12=-_HSD*_HSE;_H13=-_HSD*_HCE*_HSF;_H14=_HSD*_HCE*_HCF;
  _H21=  0.0;_H22=      _HCE;_H23=-     _HSE*_HSF;_H24=     _HSE*_HCF;
  _H31=  0.0;_H32=       0.0;_H33=           _HCF;_H34=          _HSF;
  _H41=-_HSD;_H42=-_HCD*_HSE;_H43=-_HCD*_HCE*_HSF;_H44=_HCD*_HCE*_HCF;
}
/*
 * function to draw cubic
 */
static void cuber4_( double xf, double yf, double zf, double wf,
                    double xt, double yt, double zt, double wt, int flg )
{
  int i, c;
  double x0, y0, z0, w0, x1, y1, z1, w1;
  static int l[32][2] = {
    {  0,  1 }, {  0,  2 }, {  2,  3 }, {  1,  3 },
    {  8,  9 }, {  8, 10 }, { 10, 11 }, {  9, 11 },
    {  4,  5 }, {  4,  6 }, {  6,  7 }, {  5,  7 },
    {  3,  7 }, {  3, 11 }, { 11, 15 }, {  7, 15 },
    {  0,  4 }, {  0,  8 }, {  4, 12 }, {  8, 12 },
    {  1,  5 }, {  1,  9 }, {  9, 13 }, {  5, 13 },
    {  2,  6 }, {  2, 10 }, { 10, 14 }, {  6, 14 },
    { 12, 13 }, { 12, 14 }, { 14, 15 }, { 13, 15 },
  };

  c = getcolor();
  for ( i=0; i<32; i++ ){
    x0 = (l[i][0]/1%2)?xt:xf; x1 = (l[i][1]/1%2)?xt:xf;
    y0 = (l[i][0]/2%2)?yt:yf; y1 = (l[i][1]/2%2)?yt:yf;
    z0 = (l[i][0]/4%2)?zt:zf; z1 = (l[i][1]/4%2)?zt:zf;
    w0 = (l[i][0]/8%2)?wt:wf; w1 = (l[i][1]/8%2)?wt:wf;
    if ( flg ) setcolor( i/4+1 );
    liner4_( x0, y0, z0, w0, x1, y1, z1, w1 );
  }
  setcolor( c );
}
#endif
