/*
 * Include File < graphs3_.h >
 *
 * 3-Dimensional Stereo Graphics Interface for BGI
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHS3__H_
#define _GRAPHS3__H_
#include <graphp3_.h>

/*
  3ƥ쥪եå(3-dimensional Stereo Graphics)ѥå
  
  3βžɸϤ2ƩѴܤ,
  Ωλ¸뤿ΥѥåǤ.
  ̿'sl_'ղäΤѤ̿,
  'sr_'ղäΤѤ̿Ǥ.
  ޤ,Ʊ̿ѰդƤ, ̿'s3_'
  ղä̾ΤˤʤäƤޤ. ǥեͤǺѴֿ򥻥å,
  ѴĿ򥻥åȤԤޤ. ѹǽǤ.

  㤨Хǥץ쥤˥ƥ쥪եåľ(X:0..1,Y:0..2,Z:0..3)
  ˤϰʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );   ̤100x100ΰȤ
    setmagnify( 1.5 );                    ƤȤγΨ
    setrotationport_( 0, 0, 0, 1, 2, 3 ); ˾βžɸϤ
    setrotation_( RAD(-15), RAD(20), 0 ); žѤ
    setdistance_( 0.5 );                  Υ
    stereodistance_( 0.5 );               ƥ쥪ջΥ
    cubes3_( 0, 0, 0, 1, 2, 3, !0 );      žɸϤƱľΤ

  ʲΤ褦ΩλμˡѹǤޤ
    setstereotype( ColorGlass );          ᥬΩλ
    setstereotype( DoubleImage );         2Ωλ

  ޤʲΤ褦˥桼ΩλѼ³Ǥޤ
    setstereoprocedures( start_proc, left_proc, right_proc, end_proc );

  2ΩλΤȤϡʲΤ褦ѹǤޤ
  widthʤˡˤʤޤ
    stereowidthimages( width );
 */

/* By using colored glasses */
static int _SC;
static struct fillsettingstype _SFS;
static void ColorGlassSproc(void)
{
  _SC = getcolor();
  getfillsettings( &_SFS );
}
static void ColorGlassLproc(void)
{
  setcolor( LIGHTRED );
  setfillstyle( CLOSE_DOT_FILL, RED );
}
static void ColorGlassRproc(void)
{
  setcolor( LIGHTBLUE );
  setfillstyle( CLOSE_DOT_FILL, BLUE );
}
static void ColorGlassEproc(void)
{
  setcolor( _SC );
  setfillstyle( _SFS.pattern, _SFS.color );
}
/* By using 2 images in double sides */
static double _SVL, _SVT, _SVR, _SVB, _SVC;
static int _SW = 150;
static void stereowidthimages( int width )
{
  _SW = width;
}
static void DoubleImageSproc( void )
{
  _SVL = _VL; _SVT = _VT; _SVR = _VR; _SVB = _VB; _SVC = _VC;
}
static void DoubleImageLproc( void )
{
  setviewport_( (_SVR+_SVL*3)/4-_SW/2, (_SVB+_SVT*3)/4,
                (_SVR*3+_SVL)/4-_SW/2, (_SVB*3+_SVT)/4, _SVC );
}
static void DoubleImageRproc( void )
{
  setviewport_( (_SVR+_SVL*3)/4+_SW/2, (_SVB+_SVT*3)/4,
                (_SVR*3+_SVL)/4+_SW/2, (_SVB*3+_SVT)/4, _SVC );
}
static void DoubleImageEproc( void )
{
  setviewport_( _SVL, _SVT, _SVR, _SVB, _SVC );
}
static void (*sSproc)(void) = ColorGlassSproc;
static void (*sLproc)(void) = ColorGlassLproc;
static void (*sRproc)(void) = ColorGlassRproc;
static void (*sEproc)(void) = ColorGlassEproc;
static void setstereoprocedures( void (*start)(void),
                                void (*left)(void), void (*right)(void),
                                void (*end)(void)  )
{
  if ( start != NULL ) sSproc = start; else sSproc = ColorGlassSproc;
  if ( left  != NULL ) sLproc = left;  else sLproc = ColorGlassLproc;
  if ( right != NULL ) sRproc = right; else sRproc = ColorGlassRproc;
  if ( end   != NULL ) sEproc = end;   else sEproc = ColorGlassEproc;
}
enum { ColorGlass, DoubleImage };
static void setstereotype( int type )
{
  switch ( type ){
  case ColorGlass:
    setstereoprocedures( ColorGlassSproc,
                         ColorGlassLproc, ColorGlassRproc,
                         ColorGlassEproc );
    break;
  case DoubleImage:
    setstereoprocedures( DoubleImageSproc,
                         DoubleImageLproc, DoubleImageRproc,
                         DoubleImageEproc );
    break;
  }
}

static double _SD = (1.0/0.5)/100;
/*
 * macros for stereo L space to R2 space
 */
#define sltox(x,y,z) ((r3tox(x,y,z)+_SD)*_PV/(r3toz(x,y,z)+_P3TH))
#define sltoy(x,y,z) p3toy(x,y,z)
#define sltoz(x,y,z) p3toz(x,y,z)
/*
 * macros for stereo R space to R2 space
 */
#define srtox(x,y,z) ((r3tox(x,y,z)-_SD)*_PV/(r3toz(x,y,z)+_P3TH))
#define srtoy(x,y,z) p3toy(x,y,z)
#define srtoz(x,y,z) p3toz(x,y,z)
/*
 * mocros to draw object by left eye
 */
#define linesl_(x1,y1,z1,x2,y2,z2) \
                             line_(sltox(x1,y1,z1),sltoy(x1,y1,z1), \
                                   sltox(x2,y2,z2),sltoy(x2,y2,z2))
#define linetosl_(x,y,z)     lineto_(sltox(x,y,z),sltoy(x,y,z))
#define putpixelsl_(x,y,z,c) putpixel_(sltox(x,y,z),sltoy(x,y,z),c)
#define movetosl_(x,y,z)     moveto_(sltox(x,y,z),sltoy(x,y,z))
#define outtextxysl_(x,y,z,str) \
                             outtextxy_(sltox(x,y,z),sltoy(x,y,z),str)
/*
 * mocros to draw object by right eye
 */
#define linesr_(x1,y1,z1,x2,y2,z2) \
                             line_(srtox(x1,y1,z1),srtoy(x1,y1,z1), \
                                   srtox(x2,y2,z2),srtoy(x2,y2,z2))
#define linetosr_(x,y,z)     lineto_(srtox(x,y,z),srtoy(x,y,z))
#define putpixelsr_(x,y,z,c) putpixel_(srtox(x,y,z),srtoy(x,y,z),c)
#define movetosr_(x,y,z)     moveto_(srtox(x,y,z),srtoy(x,y,z))
#define outtextxysr_(x,y,z,str) \
                             outtextxy_(srtox(x,y,z),srtoy(x,y,z),str)
/*
 * mocros to draw object by eyes
 */
#define lines3_(x1,y1,z1,x2,y2,z2) \
                               do{sSproc(); \
                                  sLproc();linesl_(x1,y1,z1,x2,y2,z2); \
                                  sRproc();linesr_(x1,y1,z1,x2,y2,z2); \
                                  sEproc();}while(0)
#define linetos3_(x,y,z)       do{sSproc(); \
                                  sLproc();linetosl_(x,y,z); \
                                  sRproc();linetosr_(x,y,z); \
                                  sEproc();}while(0)
#define putpixels3_(x,y,z,c)   do{sSproc(); \
                                  sLproc();putpixelsl_(x,y,z,getcolor()); \
                                  sRproc();putpixelsr_(x,y,z,getcolor()); \
                                  sEproc();}while(0)
#define movetos3_(x,y,z)       do{sSproc(); \
                                  sLproc();movetosl_(x,y,z); \
                                  sRproc();movetosr_(x,y,z); \
                                  sEproc();}while(0)
#define outtextxys3_(x,y,z,str) \
                               do{sSproc(); \
                                  sLproc();outtextxysl_(x,y,z,str); \
                                  sRproc();outtextxysr_(x,y,z,str); \
                                  sEproc();}while(0)
/*
 * function to set stereo distance
 */
void stereodistance_( double d )
{
  _SD = (1.0/d)/100;
}
/*
 * function to draw cubic
 */
static void cubes3_( double xf, double yf, double zf,
                    double xt, double yt, double zt, int flg )
{
  int i, maxi;
  double x0, y0, z0, x1, y1, z1, maxz, z;
  static int l[12][2] = {
    { 0, 1 }, { 0, 2 }, { 0, 4 },
    { 1, 3 }, { 1, 5 },
    { 2, 3 },
    { 5, 4 },
    { 6, 4 }, { 6, 2 },
    { 7, 6 }, { 7, 5 }, { 7, 3 }, 
  };
  struct linesettingstype ls;

  getlinesettings( &ls );
  maxz = p3toz( xf, yf, zf );
  maxi = 0;
  for ( i=1; i<8; i++ ){
    x0 = (i/1%2)?xt:xf;
    y0 = (i/2%2)?yt:yf;
    z0 = (i/4%2)?zt:zf;
    z = p3toz( x0, y0, z0 );
    if ( z>maxz ){
      maxz = z;
      maxi = i;
    }
  }
  for ( i=0; i<12; i++ ){
    x0 = (l[i][0]/1%2)?xt:xf; x1 = (l[i][1]/1%2)?xt:xf;
    y0 = (l[i][0]/2%2)?yt:yf; y1 = (l[i][1]/2%2)?yt:yf;
    z0 = (l[i][0]/4%2)?zt:zf; z1 = (l[i][1]/4%2)?zt:zf;
    if ( flg && ( l[i][0]==maxi || l[i][1]==maxi ) )
      setlinestyle( DOTTED_LINE, 0, NORM_WIDTH );
    else
      setlinestyle( SOLID_LINE, 0, NORM_WIDTH );
    lines3_( x0, y0, z0, x1, y1, z1 );
  }
  setlinestyle( ls.linestyle, ls.upattern, ls.thickness );
}
/*
 * function to draw box
 */
static void boxs3_( double xf, double yf, double zf, double xt,
                   double yt, double zt, int c6[] )
{
  int i, j, fil[6];
  double x, y, z, xy[5*2], xyz[3][3], A[3], B[3];
  static int s[6][5] = {
    { 0, 1, 3, 2, 0 },
    { 0, 2, 6, 4, 0 },
    { 0, 4, 5, 1, 0 },
    { 1, 5, 7, 3, 1 },
    { 3, 7, 6, 2, 3 },
    { 4, 6, 7, 5, 4 },
  };
  struct fillsettingstype fs;
  
  getfillsettings( &fs );
  for ( i=0; i<6; i++ ){
    for ( j=0; j<3; j++ ){
      x = p3tox((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
      y = p3toy((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
      z = p3toz((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
      xyz[j][0] = x;
      xyz[j][1] = y;
      xyz[j][2] = z;
    }
    A[0] = xyz[1][0] - xyz[0][0];
    A[1] = xyz[1][1] - xyz[0][1];
    /*A[2] = xyz[1][2] - xyz[0][2];*/
    B[0] = xyz[2][0] - xyz[1][0];
    B[1] = xyz[2][1] - xyz[1][1];
    /*B[2] = xyz[2][2] - xyz[1][2];*/
    fil[i] = A[0]*B[1]-A[1]*B[0]<0;
  }
  sSproc();
  for ( i=0; i<6; i++ ){
    if ( fil[i] ){
      for ( j=0; j<5; j++ ){
        x = p3tox((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        y = p3toy((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        z = p3toz((s[i][j]/1%2)?xt:xf,(s[i][j]/2%2)?yt:yf,(s[i][j]/4%2)?zt:zf);
        xy[2*j+0] = x;
        xy[2*j+1] = y;
      }
      setfillstyle( fs.pattern, c6?c6[i]:fs.color );
      sLproc(); fillpoly_( 4, xy );
      sRproc(); fillpoly_( 4, xy );
    }
  }
  sEproc();
  setfillstyle( fs.pattern, fs.color );
}
/*
 * function to draw left hand
 */
static void lefthands3_( double xf, double yf, double zf,
                        double xt, double yt, double zt, int flg )
{
  double borderx = (xt-xf)*0.1, bordery = (yt-yf)*0.1, borderz = (zt-zf)*0.1;

  lines3_( xf-borderx, yf-bordery, zf-borderz,
           xf+borderx, yf-bordery, zf-borderz );
  lines3_( xf-borderx, yf-bordery, zf-borderz,
           xf-borderx, yf+bordery, zf-borderz );
  lines3_( xf-borderx, yf-bordery, zf-borderz,
           xf-borderx, yf-bordery, zf+borderz );
  if ( flg ){
    outtextxys3_( xf+borderx, yf-bordery, zf-borderz, "x" );
    outtextxys3_( xf-borderx, yf+bordery, zf-borderz, "y" );
    outtextxys3_( xf-borderx, yf-bordery, zf+borderz, "z" );
  }
}
#endif /* _GRAPHS3__H_ */
