/*
 * Include File < graphr4_.h >
 *
 * 4-Dimensional Stereo Graphics Interface for BGI
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHS4__H_
#define _GRAPHS4__H_
#include <graphp4_.h>
#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

/*
  4ƥ쥪եå(4-dimensional Stereo Graphics)ѥå
  
  4βžɸϤ3ɸϤѴ, 3βžɸϤ
  2ƩѴܤ, Ωλ¸뤿ΥѥåǤ.

  㤨Хǥץ쥤˲ۤĶľ(X:0..1,Y:0..2,Z:0..3,W:0..4)ˤ
  ʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );           ̤100x100ΰȤ
    hypermagnify_( 1.5 );                         ƤȤγΨ
    hyperrotationport_( 0, 0, 0, 0, 1, 2, 3, 4 ); ˾βžɸϤ
    setrotation_( RAD(-15), RAD(20), 0 );         žѤ(X,Y,Z)
    hyperrotation_( RAD(-15), RAD(45), 0 );       žѤ(XW,YW,ZW)
    setdistance_( 0.5 );                          Υ
    stereodistance_( 0.5 );                       ƥ쥪ջΥ
    cubes4_( 0, 0, 0, 0, 1, 2, 3, 4, !0 );        žɸϤƱľΤ
 */

/*
 * macros to draw on window port
 */
#define lines4_(x1,y1,z1,w1,x2,y2,z2,w2) \
             lines3_(r4tox(x1,y1,z1,w1),r4toy(x1,y1,z1,w1),r4toz(x1,y1,z1,w1),\
                     r4tox(x2,y2,z2,w2),r4toy(x2,y2,z2,w2),r4toz(x2,y2,z2,w2))
#define linetos4_(x,y,z,w) \
                        linetos3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toz(x,y,z,w))
#define putpixels4_(x,y,z,w,c) \
                    putpixels3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toz(x,y,z,w),c)
#define movetos4_(x,y,z,w) \
                        movetos3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toz(x,y,z,w))
#define outtextxys4_(x,y,z,w,str) \
                 outtextxys3_(r4tox(x,y,z,w),r4toy(x,y,z,w),r4toy(x,y,z,w),str)
/*
 * function to draw cubic
 */
static void cubes4_( double xf, double yf, double zf, double wf,
                    double xt, double yt, double zt, double wt, int flg )
{
  int i, c;
  double x0, y0, z0, w0, x1, y1, z1, w1;
  static int l[32][2] = {
    {  0,  1 }, {  0,  2 }, {  2,  3 }, {  1,  3 },
    {  8,  9 }, {  8, 10 }, { 10, 11 }, {  9, 11 },
    {  4,  5 }, {  4,  6 }, {  6,  7 }, {  5,  7 },
    {  3,  7 }, {  3, 11 }, { 11, 15 }, {  7, 15 },
    {  0,  4 }, {  0,  8 }, {  4, 12 }, {  8, 12 },
    {  1,  5 }, {  1,  9 }, {  9, 13 }, {  5, 13 },
    {  2,  6 }, {  2, 10 }, { 10, 14 }, {  6, 14 },
    { 12, 13 }, { 12, 14 }, { 14, 15 }, { 13, 15 },
  };

  c = getcolor();
  for ( i=0; i<32; i++ ){
    x0 = (l[i][0]/1%2)?xt:xf; x1 = (l[i][1]/1%2)?xt:xf;
    y0 = (l[i][0]/2%2)?yt:yf; y1 = (l[i][1]/2%2)?yt:yf;
    z0 = (l[i][0]/4%2)?zt:zf; z1 = (l[i][1]/4%2)?zt:zf;
    w0 = (l[i][0]/8%2)?wt:wf; w1 = (l[i][1]/8%2)?wt:wf;
    if ( flg ) setcolor( i/4+1 );
    lines4_( x0, y0, z0, w0, x1, y1, z1, w1 );
  }
  setcolor( c );
}
#endif
