/*
 * Header File < graphix.h >
 *
 * Enhanced Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHIX_H_
#define _GRAPHIX_H_

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "coniox.h"
#include "graphics.h"

#ifndef NeedFunctionPrototypes
#  if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#    define NeedFunctionPrototypes 1
#  else
#    define NeedFunctionPrototypes 0
#  endif
#endif

typedef struct _xbgi {
  int argc;
  char **argv;
  int id;
  Display *dpy;
  Visual *vis;
  int scr;
  int depth;
  int vclass;
  Window root;
  Window *win;
  int only_ascii;
  XFontStruct *chr[MAX_CHAR_FONT+1][MAX_CHAR_SIZE+1];
  XFontStruct *bchr0[MAX_CHAR_SIZE+1];
  void *mchr0[MAX_CHAR_SIZE+1]; /* XFontSet (not defined in X11R4) */
  GC gc;
  unsigned long fg, bg, lc, dc;
  XFontStruct *fs;
  int colornames;
  Colormap colormap;
  unsigned char colortable[256];
  unsigned long pixels[MAXCOLORS+1];
  XColor rgb[MAXCOLORS+1];
  GC gcdraw, gcfill, gcpixel, gcimage;
  int gdriver, gmode, gerror;
  int npage, apage, vpage;
  int ncolor, color, bkcolor;
  struct pointtype cp;
  struct viewporttype viewport;
  struct linesettingstype lineset;
  struct textsettingstype textset;
  struct fillsettingstype fillset;
  struct palettetype palette;
  XEvent button_press_ev, button_release_ev, mouse_motion_ev;
  XEvent page_enter_ev, page_leave_ev, key_press_ev;
  XEvent configure_ev, expose_ev;
#if NeedFunctionPrototypes
  int (*button_press_handler)( int button, int x, int y );
  int (*button_release_handler)( int button, int x, int y );
  int (*mouse_motion_handler)( int button_state, int x, int y );
  int (*page_enter_handler)( int page );
  int (*page_leave_handler)( int page );
  int (*key_press_handler)( int key );
  int (*configure_handler)( void );
  int (*expose_handler)( void );
  int (*noevent_handler)( void );
  void (*driver) ( void );
  void (*_driver)( void );
#else
  int (*button_press_handler)();
  int (*button_release_handler)();
  int (*mouse_motion_handler)();
  int (*page_enter_handler)();
  int (*page_leave_handler)();
  int (*key_press_handler)();
  int (*configure_handler)();
  int (*expose_handler)();
  int (*noevent_handler)();
  void (*driver)();
  void (*_driver)();
#endif
  struct _xconio *conio;
  struct _xbgi *next;
} xbgi;

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern xbgi *_creategraph(
#if NeedFunctionPrototypes
  int __argc, char *__argv[], char *__pd
#endif
);

extern xbgi *creategraph(
#if NeedFunctionPrototypes
  int *__graphdriver, int *__graphmode, char *__pathtodriver
#endif
);

extern xbgi *thisgraph(
#if NeedFunctionPrototypes
  void
#endif
);

extern void destroygraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

extern void currentgraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _GRAPHIX_H_ */
