/*
 * Internal Include File < _bgi.h >
 *
 * Macros and Definitions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef __BGI_H_
#include <ctype.h>
#include <malloc.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "conio.h"
#include "dos.h"
#include "graphix.h"
#include "graphics.h"
#include "xbgiutl.h"
#include "bgiutl.h"
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#ifdef ENABLE_XPMLIB
#  include <X11/xpm.h>
#endif
#ifdef ENABLE_BILINGUAL
#  include "japanese.h"
#endif
#ifdef ENABLE_MULTILINGUAL
#  include <X11/Xlocale.h>
#endif

/*
 * the header of XBGI to stack
 */
extern xbgi *XBGIS;

/*
 * the current XBGI
 */
extern xbgi *XBGI;

/*
 * the current XBGI driver
 */
extern void (*XBGI_CURRENT_DRIVER)( void );

/*
 * the various macros and definitions
 */
#define minmax(a,x,b) ((((a)<=(x))&&((x)<=(b)))?(x):(((x)<(a))?(a):(b)))
#define Xx(x)         (XBGI->viewport.left+(x))
#define Xy(y)         (XBGI->viewport.top +(y))
#define xX(x)         ((x)-XBGI->viewport.left)
#define yX(y)         ((y)-XBGI->viewport.top )
#define CTRL(c)       ((c)-'a'+1)

#define eprintf(fp,fmt,err) do{ fprintf(fp,fmt,err); exit( 1 ); }while(0)

#define FatalError(err)     eprintf(stderr,"XBGI: %s; Fatal Error.    \n",err)
#define Warning(err)        fprintf(stderr,"XBGI: %s; Warning.        \n",err)
#define ReservedFuture(err) fprintf(stderr,"XBGI: %s; Reserved Future.\n",err)
#define NotSupported(err)   fprintf(stderr,"XBGI: %s; Not Supported.  \n",err)

#define DecoHemBits   1
#define DecoBrimBits  2

#define HemBrim    (DecoHemBits+DecoBrimBits)
#define Hem(size)  (DecoHemBits+(size)+DecoHemBits)
#define Brim(size) (DecoBrimBits+(size)+DecoBrimBits)

#define  ASCENT_CANNOT_FIND 14
#define DESCENT_CANNOT_FIND  2
#define   WIDTH_CANNOT_FIND  8
#define  HEIGHT_CANNOT_FIND (ASCENT_CANNOT_FIND+DESCENT_CANNOT_FIND)

#define TextHeight(fs)      ((fs!=NULL)?\
                             (fs->max_bounds.ascent+fs->max_bounds.descent):\
                             (HEIGHT_CANNOT_FIND))
#define TextAscent(fs)      ((fs!=NULL)?\
                             (fs->max_bounds.ascent):\
                             (ASCENT_CANNOT_FIND))
#define TextDescent(fs)     ((fs!=NULL)?\
                             (fs->max_bounds.descent):\
                             (DESCENT_CANNOT_FIND))
#define TextWidth(fs,p,l)   ((fs!=NULL)?\
                             (XTextWidth(fs,p,l)):\
                             (WIDTH_CANNOT_FIND*l))
#define TextWidth16(fs,p,l) ((fs!=NULL)?\
                             (XTextWidth16(fs,p,l)):\
                             (WIDTH_CANNOT_FIND*2*l))

/*
 * internal struct for draw and fill arc
 */
struct arcsettingstype {
  int x, y;
  int stangle, endangle;
  int xradius, yradius;
};

#endif /* __BGI_H_ */
