/*
 * Source File < graphics/event.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * event loop with tools
 */
/* menu defined */
enum MENU_ITEM {
  NO_SELECT = -1,
  SAVE_XBM,
#ifdef ENABLE_XPMLIB
  SAVE_XPM,
#endif
  QUIT,
};
static char *MENU_TITLE = "menu";
static int   MENU_ITEMC = QUIT+1;
static int   MENU_ITEMI = NO_SELECT;
static char *MENU_ITEMV[] = {
  "save bitmap",
#ifdef ENABLE_XPMLIB
  "save pixmap",
#endif
  "quit (q)"
};
/* about and info. defined */
#define ABOUT "xbgi\n"\
              "version 2.2\n"\
              "Borland's graphics.h for X \n"\
              "Taiji Yamada"
#define INFO  "id          %d\n"\
              "driver      %s\n"\
              "mode        %s\n"\
              "visual page %d\n"\
              "active page %d\n"\
              "pages       %d\n"\
              "color       %d\n"\
              "bkcolor     %d\n"\
              "ncolor      %d\n",\
              XBGI->id,\
              getdriversname(XBGI->gdriver),\
              getmodename(XBGI->gmode),\
              XBGI->apage,\
              XBGI->vpage,\
              XBGI->npage,\
              XBGI->color,\
              XBGI->bkcolor,\
              XBGI->ncolor
#define HELP  "-display display          X server to contact.\n"\
              "-geometry geometry        the preferrd size and position.\n"\
              "-fn font                  Font of popup text.\n"\
              "-fg color                 Display color of popup text.\n"\
              "-bg color                 Background color of popup text.\n"\
              "-title string             Title of graphic window.\n"\
              "-name name                Resouces name of graphic window.\n"\
              "-icon file                Icon bitmap filename.\n"\
              "-backing[-]               Backing store on[/off].\n"\
              "-gd driver                Graphic driver name.\n"\
              "-gm mode                  Graphic mode name.\n"\
              "-ncolor number            The number of graphic color.\n"\
              "-color number             Graphic forground color number.\n"\
              "-bkcolor number           Graphic background color number.\n"\
              "-npage number             The number of graphic page.\n"\
              "-colornames colorlist     X named color list for graphic.\n"\
              "-only_ascii[-]            The flag of bi/multiligual text.\n"\

/*
 * default event procs
 */
int BGI_button_press( int button, int x, int y )
{
  static char xbmfilename[80], xbmfilenamebak[80] = "scratch.xbm";
  static char xpmfilename[80], xpmfilenamebak[80] = "scratch.xpm";
  int status;

  switch( button ){
  case 1:
    break;
  case 2:
    bgimenu( MENU_TITLE, MENU_ITEMC, MENU_ITEMV, &MENU_ITEMI );
    switch( MENU_ITEMI ){
    case NO_SELECT:
      break;
    case SAVE_XBM:
      strcpy( xbmfilename, xbmfilenamebak );
      bgigets( "XBM NAME", 80, xbmfilename );
      if ( strcmp(xbmfilename,"") != 0 ){
        status = savegraphtoxbm( xbmfilename );
        strcpy( xbmfilenamebak, xbmfilename );
        if ( !status )
          bgiprintf( "Error!", CENTER_TEXT, "saving bitmap is failed" );
      }else{
        strcpy( xbmfilename, xbmfilenamebak );
      }
      break;
#ifdef ENABLE_XPMLIB
    case SAVE_XPM:
      strcpy( xpmfilename, xpmfilenamebak );
      bgigets( "XPM NAME", 80, xpmfilename );
      if ( strcmp(xpmfilename,"") != 0 ){
        status = savegraphtoxpm( xpmfilename );
        strcpy( xpmfilenamebak, xpmfilename );
        if ( !status )
          bgiprintf( "Error!", CENTER_TEXT, "saving pixmap is failed" );
      }else{
        strcpy( xpmfilename, xpmfilenamebak );
      }
      break;
#endif
    case QUIT:
      return 0;
      break;
    }
    break;
  case 3:
    return 0;
    break;
  }
  return !0;
}
int BGI_button_release( int button, int x, int y )
{
  return !0;
}
int BGI_mouse_motion( int button_state, int x, int y )
{
  return !0;
}
int BGI_page_enter( int page )
{
  return !0;
}
int BGI_page_leave( int page )
{
  return !0;
}
int BGI_key_press( int c )
{
  int i;
  char buf[256];

  switch( c ){
  case CTRL('a'):
    bgiprintf( "about", CENTER_TEXT, ABOUT );
    break;
  case CTRL('i'):
    bgiprintf( "info.", LEFT_TEXT, INFO );
    break;
  case CTRL('o'):
    strcpy( buf, "" );
    for ( i=0; i<XBGI->argc; i++ ){
      if ( XBGI->argv[i][0] == '-' )
        strcat( buf, "\n" );
      strcat( buf, XBGI->argv[i] );
      if ( XBGI->argv[i][0] == '-' )
        strcat( buf, " " );
    }
    bgiprintf( "options", LEFT_TEXT, "%s", buf );
    break;
  case CTRL('h'):
    bgiprintf( "help", LEFT_TEXT, HELP );
    break;
  case 'n': case 'N':
    setvisualpage( min( XBGI->vpage+1, XBGI->npage-1 ) );
    break;
  case 'b': case 'B':
    setvisualpage( XBGI->vpage-1 );
    break;
  case CTRL('f'):
    if ( XBGI->vpage != XBGI->npage )
      setvisualpage( XBGI->npage );
    else
      setvisualpage( 0 );
    break;
  case CTRL('c'):
    exit( 0 );
    break;
  case 'q': case 'Q': case 0x1b:
    return 0;
    break;
  }
  return !0;
}
int BGI_configure( void )
{
  return !0;
}
int BGI_expose( void )
{
  return !0;
}
int BGI_noevent( void )
{
  return !0;
}

/*
 * event looper for simple event programing
 */
void xbgiloop( void )
{
  xbgi *ptr;
  XEvent ev;
  int b, bs, p;
  char c;
  int ret;
  
  /*
   * flush all xbgi
   */
  ptr = XBGIS;
  while ( ptr != NULL ){
    XFlush( ptr->dpy );
    ptr = ptr->next;
  }
  ptr = XBGI;
  XBGI = XBGIS;
  /*
   * finite event roop
   */
  while ( !0 ){
    if ( XBGI == NULL ){
      XBGI = XBGIS;
      continue;
    }
    ret = !0;
    if ( XEventsQueued( XBGI->dpy, QueuedAfterFlush ) > 0 ){
      XNextEvent( XBGI->dpy, &ev );
      switch ( ev.type ){
      case ButtonPress:
        XBGI->button_press_ev = ev;
        if ( XBGI->button_press_handler != NULL ){
          switch( ev.xbutton.button ){
          case Button1: b = 1; break;
          case Button2: b = 2; break;
          case Button3: b = 3; break;
          }
          ret = XBGI->button_press_handler( b, ev.xbutton.x, ev.xbutton.y );
        }
        break;
      case ButtonRelease:
        XBGI->button_release_ev = ev;
        if ( XBGI->button_release_handler != NULL ){
          switch( ev.xbutton.button ){
          case Button1: b = 1; break;
          case Button2: b = 2; break;
          case Button3: b = 3; break;
          }
          ret = XBGI->button_release_handler( b, ev.xbutton.x, ev.xbutton.y );
        }
        break;
      case MotionNotify:
        XBGI->mouse_motion_ev = ev;
        if ( XBGI->mouse_motion_handler != NULL ){
          bs = 0;
          if ( ev.xmotion.state & Button1Mask ) bs |= 1;
          if ( ev.xmotion.state & Button2Mask ) bs |= 2;
          if ( ev.xmotion.state & Button3Mask ) bs |= 4;
          ret = XBGI->mouse_motion_handler( bs, ev.xbutton.x, ev.xbutton.y );
        }
        break;
      case EnterNotify:
        XBGI->page_enter_ev = ev;
        if ( XBGI->page_enter_handler != NULL ){
          for ( p=0; p<XBGI->npage; p++ )
            if ( XBGI->win[p] == ev.xcrossing.window )
              ret = XBGI->page_enter_handler( p );
        }
        break;
      case LeaveNotify:
        XBGI->page_leave_ev = ev;
        if ( XBGI->page_leave_handler != NULL ){
          for ( p=0; p<XBGI->npage; p++ )
            if ( XBGI->win[p] == ev.xcrossing.window )
              ret = XBGI->page_leave_handler( p );
        }
        break;
      case KeyPress:
        if ( XLookupString( (XKeyEvent*)&ev, &c, 1, NULL, NULL ) == 1 ){
          XBGI->key_press_ev = ev;
          if ( XBGI->key_press_handler != NULL )
            ret = XBGI->key_press_handler( c );
        }
        break;
      case ConfigureNotify:
        if ( XBGI->configure_handler != NULL )
          ret = XBGI->configure_handler();
        break;
      case Expose:
        if ( XBGI->expose_handler != NULL )
          ret = XBGI->expose_handler();
        break;
      }
    }else{
      if ( XBGI->noevent_handler != NULL )
        ret = XBGI->noevent_handler();
    }
    if ( !ret ){
      XBGI = ptr;
      return;
    }
    XBGI = XBGI->next;
  }
}

/*
 * following functions are customizing of xbgiloop
 */
void set_button_press_handler( int (*proc)( int b, int x, int y ) )
{
  XBGI->button_press_handler = proc;
}
void set_button_release_handler( int (*proc)( int b, int x, int y ) )
{
  XBGI->button_release_handler = proc;
}
void set_mouse_motion_handler( int (*proc)( int b, int x, int y ) )
{
  XBGI->mouse_motion_handler = proc;
}
void set_page_enter_handler( int (*proc)( int p ) )
{
  XBGI->page_enter_handler = proc;
}
void set_page_leave_handler( int (*proc)( int p ) )
{
  XBGI->page_leave_handler = proc;
}
void set_key_press_handler( int (*proc)( int c ) )
{
  XBGI->key_press_handler = proc;
}
void set_configure_handler( int (*proc)( void ) )
{
  XBGI->configure_handler = proc;
}
void set_expose_handler( int (*proc)( void ) )
{
  XBGI->expose_handler = proc;
}
void set_noevent_handler( int (*proc)( void ) )
{
  XBGI->noevent_handler = proc;
}
