/*
 * Source File < graphics/image.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * standard functions to get and put image
 */
unsigned imagesize( int left, int top, int right, int bottom )
{
  return (unsigned)(2 + (abs(right-left)+1)*(abs(bottom-top)+1));
}
void getimage( int left, int top, int right, int bottom, void *bitmap )
{
  XImage *image;
  int width, height, i, j, k;
  unsigned char *data, *buffer = (unsigned char *)bitmap;

  width  = abs(right-left)+1;
  height = abs(bottom-top)+1;
  image = XGetImage( XBGI->dpy, XBGI->win[XBGI->apage],
                    min(Xx(left),Xx(right)), min(Xy(top),Xy(bottom)),
                    width, height, AllPlanes, ZPixmap );
  data = (unsigned char *)image->data;
  *buffer++ = width;
  *buffer++ = height;
  for ( i=0; i<height; i++ ){
    for ( k=j=0; j<image->bytes_per_line; j++, data++ ){
      if ( j<image->xoffset ) continue;
      k++;
      if ( width < k ) continue;
      *buffer++ = XBGI->colortable[*data];
    }
  }
  XDestroyImage( image );
}
void putimage( int left, int top, void *bitmap, int op )
{
  static int OP2GX[] = {
    GXcopy, GXxor, GXor, GXand, GXcopyInverted,
  };
  int i;
  int width, height;
  XImage *image;
  unsigned char *src, *dst, *buffer = (unsigned char *)bitmap;
  
  width  = buffer[0];
  height = buffer[1];
  src = buffer + 2;
  dst = (unsigned char *)malloc( width*height*sizeof(unsigned char) );
  for ( i=0; i<width*height; i++ )
    dst[i] = XBGI->pixels[src[i]];
  XSetFunction( XBGI->dpy, XBGI->gcimage, OP2GX[minmax(COPY_PUT,op,NOT_PUT)] );
  image = XCreateImage( XBGI->dpy, DefaultVisual(XBGI->dpy,XBGI->scr),
                       XBGI->depth, ZPixmap, 0, (char *)dst,
                       width, height, 8, 0 );
  XPutImage( XBGI->dpy, XBGI->win[XBGI->apage], XBGI->gcimage, image,
            0, 0, Xx(left), Xy(top), width, height );
  XDestroyImage( image );
  free( dst );
}
