/*
 * japanese code system utilities < jutil.h >
 *
 * ܸΥηϤ˴ؤ桼ƥƥ
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _JUTIL_H_
#define _JUTIL_H_

/*
 * s2code: (unsigned char *)Υ(unsigned short )
 * codec1: (unsigned short )ξ̥ХȤ
 * codec2: (unsigned short )β̥ХȤ
 */
#define s2code(s) ((unsigned short)(s[0]<<8|s[1]))
#define codec1(c) ((char)((c)>>8))
#define codec2(c) ((char)((c)&0x00ff))

/*
 * ܸ쥷եJISʸ˴ؤ
 *
 * եJISɽʸϡASCIIʸΥեåʸΰΥɤѤ
 * ХȤΥեJISɤǳǼ.
 *
 * եJISɤ˴ؤƤDOSΣåѥǰŪʰʲδؿȤ.
 *
 * iskanji : Хܤݤ
 * iskanji2: Хܤݤ
 * jmstojis: եJISJISؤΥѴ
 * jistojms: JIS饷եJISؤΥѴ
 */

/*
 * ܸJISʸ˴ؤ
 *
 * JISɤɽʸϡʸ(^[$B)Ƚλʸ(^[(J)
 * Ϥޤ줿ʸΰˡХȤJISɤǳǼ.
 *
 * JISɤ˴ؤƤϰʲʸȥޥȤ.
 *
 * _JISB1: ʸ
 * _JISE: λʸ
 * isjiss: ʸJISɤγϤ򼨤Ƥ뤫ݤ
 * isjise: ʸJISɤνλ򼨤Ƥ뤫ݤ
 */
static char _JISB1[4] = { 0x1b, '$', 'B', '\0' };
static char _JISB2[4] = { 0x1b, '$', '@', '\0' };
static char _JISE1[4] = { 0x1b, '(', 'J', '\0' };
static char _JISE2[4] = { 0x1b, '(', 'B', '\0' };
static char _JISE3[4] = { 0x1b, '(', 'H', '\0' };
#define isjiss(s) \
((strncmp(s,_JISB1,3)==0)||(strncmp(s,_JISB2,3)==0))
#define isjise(s) \
((strncmp(s,_JISE1,3)==0)||(strncmp(s,_JISE2,3)==0)||(strncmp(s,_JISE3,3)==0))
static unsigned char *whereisjiss( unsigned char *line )
{
  unsigned char *ptr;

  if ( (ptr=strstr(line,_JISB1)) == NULL ){
    if ( (ptr=strstr(line,_JISB2)) == NULL ){
      return NULL;
    }else{
      return ptr;
    }
  }else{
    return ptr;
  }
}
static unsigned char *whereisjise( unsigned char *line )
{
  unsigned char *ptr;

  if ( (ptr=strstr(line,_JISE1)) == NULL ){
    if ( (ptr=strstr(line,_JISE2)) == NULL ){
      if ( (ptr=strstr(line,_JISE2)) == NULL ){
	return NULL;
      }else{
	return ptr;
      }
    }else{
      return ptr;
    }
  }else{
    return ptr;
  }
}

/*
 * ܸEUCʸ˴ؤ
 *
 * EUCɽʸϡASCIIʸȾѤʸΰΥɤѤ
 * ХȤJISɤ0x80ûɤǳǼ.
 *
 * EUCɤ˴ؤƤϰʲΥޥȤ.
 *
 * iseuc   : Хܤݤ
 * iseuc2  : Хܤݤ
 * euctojis: EUCJISؤΥѴ
 * jistoeuc: JISEUCؤΥѴ
 * euctojms: EUC饷եJISؤΥѴ
 * jmstoeuc: եJISEUCؤΥѴ
 */
#define iseuc(c)  (0xa0<=(c)&&(c)<0xe0)
#define iseuc2(c) (0xa1<=(c)&&(c)<0xff)
#define euctojis(u) ((u)-0x8080)
#define jistoeuc(u) ((u)+0x8080)
#define euctojms(u) jistojms(euctojis(u))
#define jmstoeuc(u) jistoeuc(jmstojis(u))

/*
 *   0: , 1: եJIS, 2: JIS, 3: EUC
 */
enum _JCODES { JCT_ILGL = -1, JCT_ANK, JCT_SJ, JCT_JIS, JCT_EUC };

/*
 * Ϳ줿ʸ󤬤ɤΥηϤɽƤ뤫֤.
 */
static int jcode( unsigned char *str )
{
  unsigned char *ptr;

  /* JCT_JIS */
  if ( whereisjiss( str ) != NULL || whereisjise( str ) != NULL )
    return JCT_JIS;
  /* JCT_ANK */
  ptr = str;
  while ( *ptr != '\0' ){
    if ( !iscntrl(*ptr) && !isprint(*ptr) )
      break;
    ptr++;
  }
  if ( *ptr == '\0' ) return JCT_ANK;
  /* JCT_EUC */
  ptr = str;
  while ( *ptr != '\0' ){
    if ( iseuc(*ptr) ){
      if ( iseuc2(*(ptr+1)) ){
        ptr += 2;
      }else{
        break;
      }
    }else if ( iscntrl(*ptr) || isprint(*ptr) ){
      ptr++;
    }else{
      break;
    }
  }
  if ( *ptr == '\0' ) return JCT_EUC;
  /* JCT_SJ */
  ptr = str;
  while ( *ptr != '\0' ){
    if ( iskanji(*ptr) ){
      if ( iskanji2(*(ptr+1)) ){
        ptr += 2;
      }else{
        break;
      }
    }else if ( iscntrl(*ptr) || isprint(*ptr) || iskana(*ptr) ){
      ptr++;
    }else{
      break;
    }
  }
  /*if ( *ptr == '\0' )*/ return JCT_SJ;
  /*return JCT_ILGL;*/
}

/*
 * Ϳ줿ȥ꡼बɤΥηϤɽƤ뤫֤.
 */
static int jfcode( FILE *fp )
{
  int code, codes[] = { 0, 0, 0, 0 };
  long fpos;
  unsigned char buf[2048];

  if ( fp != stdin ) fpos = ftell( fp );
  while ( fgets(buf,2048,fp) != NULL ){
     code = jcode( buf );
     if ( code == JCT_JIS ){
       if ( fp != stdin ) fseek( fp, fpos, 0 );
       return JCT_JIS;
     }else if ( code != JCT_ILGL ){
       codes[code]++;
     }
  }
  if ( fp != stdin ) fseek( fp, fpos, 0 );
  if ( codes[JCT_SJ] == 0 && codes[JCT_EUC] == 0 ) return JCT_ANK;
  if ( codes[JCT_SJ] < codes[JCT_EUC] ) return JCT_EUC;
  return JCT_SJ;
}

/*
 * ɴѴؿ: SJ<->JIS, JIS<->EUC, EUC<->SJ
 * եJISJISѴ: sj2jis ( src, dst )
 * JIS饷եJISѴ: jis2sj ( src, dst )
 * JISEUCɤѴ: jis2euc( src, dst )
 * EUCJISɤѴ: euc2jis( src, dst )
 * EUC饷եJISѴ: euc2sj ( src, dst )
 * եJISEUCѴ: sj2euc ( src, dst )
 *
 * :
 * Ѵʸ: src
 * Ѵʸ: dst
 *
 * :
 * dst ˤϽʬΰ褬ݤƤʤФʤʤ.
 */

/*
 * ȾѥʤѥʤѴ.
 */
static unsigned short kanatozen( unsigned short c )
{
  static unsigned short kana_to_zen_table[63] = {
    /* ֡ס*/ 0x8142, 0x8175, 0x8176, 0x8141, 0x8145,
    /**/          0x8392,
    /**/  0x8340, 0x8342, 0x8344, 0x8346, 0x8348,
    /*á*/  0x8383, 0x8385, 0x8387, 0x8362, 0x815b,
    /**/  0x8341, 0x8343, 0x8345, 0x8347, 0x8349,
    /**/  0x834a, 0x834c, 0x834e, 0x8350, 0x8352,
    /**/  0x8354, 0x8356, 0x8358, 0x835a, 0x835c,
    /*ĥƥ*/  0x835e, 0x8360, 0x8363, 0x8365, 0x8367,
    /*ʥ˥̥ͥ*/  0x8369, 0x836a, 0x836b, 0x836c, 0x836d,
    /*ϥҥեإ*/  0x836e, 0x8371, 0x8374, 0x8377, 0x837a,
    /*ޥߥ*/  0x837d, 0x837e, 0x8380, 0x8381, 0x8382,
    /**/  0x8384, 0x8386, 0x8388, 0x8389, 0x838a,
    /**/  0x838b, 0x838c, 0x838d, 0x838f, 0x8393,
    /**/        0x814a, 0x818b,
  };

  if ( 0xa1 <= (unsigned char)c && (unsigned char)c <= 0xdf )
    return kana_to_zen_table[(int)((unsigned char)c-0xa1)];
  return hantozen( c );
}

/*
 * ȾѥʤѥʤʤɤθѴ.
 */
static unsigned short kana2zen( unsigned char *ptr, int *ptr_step )
{
  static unsigned short kana_2_zen_table[2][30] = {
    { /*  */
      /*  */ 0x0000, 0x0000, 0x8394, 0x0000, 0x0000,
      /*  */ 0x834b, 0x834d, 0x834f, 0x8351, 0x8353,
      /*  */ 0x8355, 0x8357, 0x8359, 0x835b, 0x835d,
      /* ĥƥ */ 0x835f, 0x8361, 0x8364, 0x8366, 0x8368,
      /* ʥ˥̥ͥ */ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
      /* ϥҥեإ */ 0x836f, 0x8372, 0x8375, 0x8378, 0x837b
    },
    { /* Ⱦ */
      /*  */ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
      /*  */ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
      /*  */ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
      /* ĥƥ */ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
      /* ʥ˥̥ͥ */ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
      /* ϥҥեإ */ 0x8370, 0x8373, 0x8376, 0x8379, 0x837c
    },
  };

  if ( (0xde==*(ptr+1)||0xdf == *(ptr+1)) && (0xb1<=*ptr&&*ptr<=0xce) 
      &&(kana_2_zen_table[*(ptr+1)-0xde][*ptr-0xb1]) ){
    *ptr_step = 2;
    return kana_2_zen_table[*(ptr+1)-0xde][*ptr-0xb1];
  }
  *ptr_step = 1;
  return kanatozen(*ptr);
}

/*
 * եJISɤɽ줿ʸJISɤѴ.
 */
static void sj2jis( unsigned char *src, unsigned char *dst )
{
  unsigned short jisc;
  int code, c;

  code = JCT_ANK;
  while ( *src != '\0' ){
    if ( !iskana(*src) && !(iskanji(*src)&&iskanji2(*(src+1))) ){
      if ( code == JCT_SJ ){
        *dst++ = _JISE1[0];
        *dst++ = _JISE1[1];
        *dst++ = _JISE1[2];
      }
      code = JCT_ANK;
      *dst++ = *src++;
    }else{
      if ( code == JCT_ANK ){
        *dst++ = _JISB1[0];
        *dst++ = _JISB1[1];
        *dst++ = _JISB1[2];
      }
      code = JCT_SJ;
      if ( !iskana(*src) ){
        jisc = jmstojis( s2code(src) );
        src += 2;
      }else{
        jisc = jmstojis( kana2zen(src,&c) );
        src += c;
      }
      *dst++ = codec1(jisc);
      *dst++ = codec2(jisc);
    }
  }
  if ( code == JCT_SJ ){
    *dst++ = _JISE1[0];
    *dst++ = _JISE1[1];
    *dst++ = _JISE1[2];
  }
  *dst = '\0';
}

/*
 * JISɤɽ줿ʸ򥷥եJISɤѴ.
 */
static void jis2sj( unsigned char *src, unsigned char *dst )
{
  unsigned short sjis;
  int code;

  code = JCT_ANK;
  if ( whereisjiss( src ) > whereisjise( src ) )
    code = JCT_JIS;
  while ( *src != '\0' ){
    if ( isjise(src) ){
      code = JCT_ANK;
      src += 3;
    }else if ( isjiss(src) ){
      code = JCT_JIS;
      src += 3;
    }else{
      if ( code == JCT_ANK ){
        *dst++ = *src++;
      }else{
        sjis = jistojms( s2code(src) );
        *dst++ = codec1(sjis);
        *dst++ = codec2(sjis);
        src += 2;
      }
    }
  }
  *dst = '\0';
}

/*
 * JISɤɽ줿ʸEUCɤѴ.
 */
static void jis2euc( unsigned char *src, unsigned char *dst )
{
  unsigned short eucc;
  int code;

  code = JCT_ANK;
  if ( whereisjiss( src ) > whereisjise( src ) )
    code = JCT_JIS;
  while ( *src != '\0' ){
    if ( isjise(src) ){
      code = JCT_ANK;
      src += 3;
    }else if ( isjiss(src) ){
      code = JCT_JIS;
      src += 3;
    }else{
      if ( code==JCT_ANK ){
        *dst++ = *src++;
      }else{
        eucc = jistoeuc( s2code(src) );
        *dst++ = codec1(eucc);
        *dst++ = codec2(eucc);
        src += 2;
      }
    }
  }
  *dst = '\0';
}

/*
 * EUCɤɽ줿ʸJISɤѴ.
 */
static void euc2jis( unsigned char *src, unsigned char *dst )
{
  unsigned short jisc;
  int code;

  code = JCT_ANK;
  while ( *src != '\0' ){
    if ( !(iseuc(*src)&&iseuc2(*(src+1))) ){
      if ( code == JCT_EUC ){
        *dst++ = _JISE1[0];
        *dst++ = _JISE1[1];
        *dst++ = _JISE1[2];
      }
      code = JCT_ANK;
      *dst++ = *src++;
    }else{
      if ( code == JCT_ANK ){
        *dst++ = _JISB1[0];
        *dst++ = _JISB1[1];
        *dst++ = _JISB1[2];
      }
      code = JCT_EUC;
      jisc = euctojis( s2code(src) );
      *dst++ = codec1(jisc);
      *dst++ = codec2(jisc);
      src += 2;
    }
  }
  if ( code == JCT_EUC ){
    *dst++ = _JISE1[0];
    *dst++ = _JISE1[1];
    *dst++ = _JISE1[2];
  }
  *dst = '\0';
}

/*
 * EUCɤɽ줿ʸ򥷥եJISɤѴ.
 */
static void euc2sj( unsigned char *src, unsigned char *dst )
{
  unsigned short sjis;

  while ( *src != '\0' ){
    if ( !iseuc( *src ) || !iseuc2( *(src+1) ) ){
      *dst++ = *src++;
    }else{
      sjis = euctojms( s2code(src) );
      *dst++ = codec1(sjis);
      *dst++ = codec2(sjis);
      src += 2;
    }
  }
  *dst = '\0';
}

/*
 * եJISɤɽ줿ʸEUCɤѴ.
 */
static void sj2euc( unsigned char *src, unsigned char *dst )
{
  unsigned short eucc;
  int c;

  while ( *src != '\0' ){
    if ( !iskana(*src) && !(iskanji(*src)&&iskanji2(*(src+1))) ){
      *dst++ = *src++;
    }else{
      if ( !iskana(*src) ){
        eucc = jmstoeuc( s2code(src) );
        src += 2;
      }else{
        eucc = jmstoeuc( kana2zen(src,&c) );
        src += c;
      }
      *dst++ = codec1(eucc);
      *dst++ = codec2(eucc);
    }
  }
  *dst = '\0';
}

/*
 * Ѵؿ: ɤȽ̤ƥѴؿ
 * եJISѴ: str2sj ( src, dst )
 * JISɤѴ: str2jis( src, dst )
 * EUCɤѴ: str2euc( src, dst )
 *
 * :
 * Ѵʸ: src
 * Ѵʸ: dst
 *
 * :
 * dst ˤϽʬΰ褬ݤƤʤФʤʤ.
 */

/*
 * ʸ򥷥եJISɤѴ.
 */
static void str2sj( unsigned char *src, unsigned char *dst )
{
  int code = jcode(src);

  switch ( code ){
  case JCT_ANK:
  case JCT_SJ:  strcpy( dst, src ); break;
  case JCT_JIS: jis2sj( src, dst ); break;
  case JCT_EUC: euc2sj( src, dst ); break;
  }
}

/*
 * ʸJISɤѴ.
 */
static void str2jis( unsigned char *src, unsigned char *dst )
{
  int code = jcode(src);

  switch ( code ){
  case JCT_ANK:
  case JCT_JIS: strcpy ( dst, src ); break;
  case JCT_SJ:  sj2jis ( src, dst ); break;
  case JCT_EUC: euc2jis( src, dst ); break;
  }
}

/*
 * ʸEUCɤѴ.
 */
static void str2euc( unsigned char *src, unsigned char *dst )
{
  int code = jcode(src);

  switch ( code ){
  case JCT_ANK:
  case JCT_EUC: strcpy ( dst, src ); break;
  case JCT_SJ:  sj2euc ( src, dst ); break;
  case JCT_JIS: jis2euc( src, dst ); break;
  }
}

/*
 * ȴɤ뤳ȤˤäϤؤˤ뤿δĶ
 *
 * Ϥ˴ؤؿ: jfputs, jputs
 * ʸΥȥ꡼ؽ񤭹: jfputs( str, fp )
 *     : ʸ: char *str, ե륹ȥ꡼: FILE *fp
 *     : Ǥʤ, Ԥ EOF: int
 *
 * ʸɸϤؤν񤭹: jputs ( src )
 *     : ʸ: char *str
 *     : Ǥʤ, Ԥ EOF: int
 *
 * Ϥ˴ؤؿ: jfgets, jgets
 * ȥ꡼फʸɤ߹: jfgets( str, n, fp )
 *     : ʸ: char *str, Хåե: size_t n,
 *           ե륹ȥ꡼: FILE *fp
 *     :  str ؤΥݥ, Ԥ NULL: char *
 *
 * ɸϤʸɤ߹: jgets ( str )
 *     : ʸ: char *str
 *     :  str ؤΥݥ, Ԥ NULL: char *
 *
 * ϵ§:
 * ϤǤʸ󤬲ΥɤǤ⥫ȴɤǽϤ.
 * ϤǤʸ󤬲ΥɤǤ⥫ȴɤǳǼ.
 */

#ifdef __MSDOS__
static int _JCODE = JCT_SJ;
#else
static int _JCODE = JCT_EUC;
#endif

/*
 * ȴɤ: setjcode(  )
 */
static void setjcode( int c )
{
  _JCODE = c;
}

/*
 * ȴɤμ: getjcode() 
 */
static int getjcode( void )
{
  return _JCODE;
}

/*
 * եJISɤʸ򥫥ȥɤǥȥ꡼ؽ񤭹.
 */
static int sjfputs( unsigned char *src, FILE *fp )
{
  unsigned short sjis, jisc, eucc;
  int code, c;

  code = JCT_ANK;
  while ( *src != '\0' ){
    if ( !iskana(*src) && !(iskanji(*src)&&iskanji2(*(src+1))) ){
      if ( code == JCT_SJ ){
        switch ( _JCODE ){
        case JCT_JIS:
          fprintf( fp, "%s", _JISE1 );
          break;
        }
      }
      code = JCT_ANK;
      fprintf( fp, "%c", *src++ );
    }else{
      if ( code == JCT_ANK ){
        switch ( _JCODE ){
        case JCT_JIS:
          fprintf( fp, "%s", _JISB1 );
          break;
        }
      }
      code = JCT_SJ;
      if ( !iskana(*src) ){
        sjis = s2code(src);
        src += 2;
      }else{
        sjis = kana2zen(src,&c);
        src += c;
      }
      switch ( _JCODE ){
      case JCT_SJ:
        fprintf( fp, "%c%c", codec1(sjis), codec2(sjis) );
        break;
      case JCT_JIS:
        jisc = jmstojis( sjis );
        fprintf( fp, "%c%c", codec1(jisc), codec2(jisc) );
        break;
      case JCT_EUC:
        jisc = jmstojis( sjis );
        eucc = jistoeuc( jisc );
        fprintf( fp, "%c%c", codec1(eucc), codec2(eucc) );
      }
    }
  }
  if ( code == JCT_SJ ){
    switch ( _JCODE ){
    case JCT_JIS:
      fprintf( fp, "%s", _JISE1 );
      break;
    }
  }
  return 1;
}

/*
 * եJISɤʸ򥫥ȥɤɸϤؽ񤭹.
 */
static int sjputs( unsigned char *str )
{
  return sjfputs( str, stdout );
}

/*
 * JISɤʸ򥫥ȥɤǥȥ꡼ؽ񤭹.
 */
static int jisfputs( unsigned char *src, FILE *fp )
{
  unsigned short sjis, jisc, eucc;
  int code;

  code = JCT_ANK;
  if ( strstr( src, _JISB1 ) > strstr( src, _JISE1 ) ){
    code = JCT_JIS;
    switch ( _JCODE ){
    case JCT_JIS:
      fprintf( fp, "%s", _JISB1 );
      break;
    }
  }
  while ( *src != '\0' ){
    if ( isjise(src) ){
      code = JCT_ANK;
      src += 3;
      switch ( _JCODE ){
      case JCT_JIS:
        fprintf( fp, "%s", _JISE1 );
        break;
      }
    }else if ( isjiss(src) ){
      code = JCT_JIS;
      src += 3;
      switch ( _JCODE ){
      case JCT_JIS:
        fprintf( fp, "%s", _JISB1 );
        break;
      }
    }else{
      if ( code == JCT_ANK ){
        fprintf( fp, "%c", *src++ );
      }else{
        jisc = s2code(src);
        src += 2;
        switch ( _JCODE ){
        case JCT_SJ:
          sjis = jistojms( jisc );
          fprintf( fp, "%c%c", codec1(sjis), codec2(sjis) );
          break;
        case JCT_JIS:
          fprintf( fp, "%c%c", codec1(jisc), codec2(jisc) );
          break;
        case JCT_EUC:
          eucc = jistoeuc( jisc );
          fprintf( fp, "%c%c", codec1(eucc), codec2(eucc) );
        }
      }
    }
  }
  if ( code == JCT_JIS ){
    switch ( _JCODE ){
    case JCT_JIS:
      fprintf( fp, "%s", _JISE1 );
      break;
    }
  }
  return 1;
}

/*
 * JISɤʸ򥫥ȥɤɸϤؽ񤭹.
 */
static int jisputs( unsigned char *str )
{
  return jisfputs( str, stdout );
}

/*
 * EUCɤʸ򥫥ȥɤǥȥ꡼ؽ񤭹.
 */
static int eucfputs( unsigned char *src, FILE *fp )
{
  unsigned short sjis, jisc, eucc;
  int code;

  code = JCT_ANK;
  while ( *src != '\0' ){
    if ( !iseuc( *src ) || !iseuc2( *(src+1) ) ){
      if ( code == JCT_EUC ){
        switch ( _JCODE ){
        case JCT_JIS:
          fprintf( fp, "%s", _JISE1 );
          break;
        }
      }
      code = JCT_ANK;
      fprintf( fp, "%c", *src++ );
    }else{
      if ( code == JCT_ANK ){
        switch ( _JCODE ){
        case JCT_JIS:
          fprintf( fp, "%s", _JISB1 );
          break;
        }
      }
      code = JCT_EUC;
      eucc = s2code(src);
      src += 2;
      switch ( _JCODE ){
      case JCT_SJ:
        jisc = euctojis( eucc );
        sjis = jistojms( jisc );
        fprintf( fp, "%c%c", codec1(sjis), codec2(sjis) );
        break;
      case JCT_JIS:
        jisc = euctojis( eucc );
        fprintf( fp, "%c%c", codec1(jisc), codec2(jisc) );
        break;
      case JCT_EUC:
        fprintf( fp, "%c%c", codec1(eucc), codec2(eucc) );
        break;
      }
    }
  }
  if ( code == JCT_EUC ){
    switch ( _JCODE ){
    case JCT_JIS:
      fprintf( fp, "%s", _JISE1 );
      break;
    }
  }
  return 1;
}
/*
 * EUCɤʸ򥫥ȥɤɸϤؽ񤭹.
 */
static int eucputs( unsigned char *str )
{
  return eucfputs( str, stdout );
}

/*
 * ܸʸ򥫥ȥɤǥȥ꡼ؽ񤭹.
 */
static int jfputs( unsigned char *str, FILE *fp )
{
  int code;
  
  code = jcode(str);
  switch ( code ){
  case JCT_SJ:  return sjfputs ( str, fp );
  case JCT_JIS: return jisfputs( str, fp );
  case JCT_EUC: return eucfputs( str, fp );
  }
  return fputs( str, fp );
}

/*
 * ܸʸ򥫥ȥɤɸϤؽ񤭹.
 */
static int jputs( unsigned char *str )
{
  return jfputs( str, stdout );
}

/*
 * ܸʸ򥹥ȥ꡼फϤ. 
 * ХåեˤϥȥɤǳǼ.
 */
static char *jfgets( unsigned char *str, size_t n, FILE *fp )
{
  int code;
  char *ret;
  unsigned char *dum;
  
  ret = fgets( str, n, fp );
  code = jcode(str);
  if ( code == JCT_ANK || _JCODE == code ){
    return ret;
  }
  dum = (unsigned char*)malloc( (strlen(str)+1)*sizeof(char) );
  strcpy( dum, str );
  switch ( _JCODE ){
  case JCT_SJ:  str2sj ( dum, str ); break;
  case JCT_JIS: str2jis( dum, str ); break;
  case JCT_EUC: str2euc( dum, str ); break;
  }
  free( dum );
  return ret;
}

/*
 * ܸʸɸϤϤ. 
 * ХåեˤϥȥɤǳǼ.
 */
static char *jgets( unsigned char *str )
{
  int code;
  char *ret;
  unsigned char *dum;
  
  ret = gets( str );
  code = jcode(str);
  if ( code == JCT_ANK || _JCODE == code ){
    return ret;
  }
  dum = (unsigned char*)malloc( (strlen(str)+1)*sizeof(char) );
  strcpy( dum, str );
  switch ( _JCODE ){
  case JCT_SJ:  str2sj ( dum, str ); break;
  case JCT_JIS: str2jis( dum, str ); break;
  case JCT_EUC: str2euc( dum, str ); break;
  }
  free( dum );
  return ret;
}

#endif
