/*
 * routines to analyse command line options < option.h >
 *
 * ޥɥ饤󥪥ץϤΤΥ롼
 *
 * copyright (c) 1992 Taiji YAMADA
 */
#ifndef _OPTION_H_
#define _OPTION_H_
#include <stdarg.h>
#include <string.h>
#include <malloc.h>

/*
 * 1. ޥɥ饤󥪥ץ˻ꤵ줿 key ¸ߤ, ֤.
 * () ޥɥ饤 "-help" ꤵƤ
 *      scan_option( argc, argv, "-help" ) ֤, .
 *
 * 2. ޥɥ饤󥪥ץ˻ꤵ줿 key ¸ߤ,
 *   key  scanf 񼰤ľ, key ΤȤ˻ꤵ줿Ѱ
 *  ޥɥ饤ͤ򥻥åȤ, ֤.
 * () ޥɥ饤 "-geom 100x100" ˤ
 *       scan_option( argc, argv, "-geom %dx%d", &W, &H ) ֤,
 *       W, H ˤϤ줾 100, 100 .
 */
/*
 * 1. if there is key to scan in command line options, true is returned.
 * (ex.) if there is "-help" in command line options
 *       scan_option( argc, argv, "-help" ) returns !0
 *
 * 2. if there is key to scan with scanf format,
 *   value(s) is(are) scaned and !0 is returned.
 * (ex.) if there is "-geom 100x100" in command line options
 *       scan_option( argc, argv, "-geom %dx%d", &W, &H ) returns !0 and
 *       sets W, H to 100, 100 respectively.
 */
static int scan_option( int argc, char *argv[], char *key, ... )
{
  int i, idx;
  char opt[64], fmt[64], buf[256], *ptr;
  va_list argptr;
#ifndef ENABLE_VSSCANF
#define VLIST10(V) V[0],V[1],V[2],V[3],V[4],V[5],V[6],V[7],V[8],V[9]
  int c;
  void **val;
#endif

  strcpy( opt, key );
  if ( (ptr=strchr(opt,'%')) != NULL ){
    strcpy( fmt, ptr );
    *ptr = '\0';
    while ( *(--ptr)==' ' ) *ptr = '\0';
  }else{
    for ( i=1; i<argc; i++ )
      if ( strcmp( argv[i], key )==0 )
        return i;
    return( 0 );
  }

#ifndef ENABLE_VSSCANF
  c = 0;
  ptr = strchr( fmt, '%' );
  while ( ptr != NULL ){
    c++;
    ptr = strchr( ptr+1, '%' );
  }
  val = (void**)malloc( (c+1)*sizeof(void*) );
  va_start( argptr, key );
  for ( i=0; i<c; i++ ){
    val[i] = va_arg( argptr, void* );
  }
  val[i] = NULL;
  va_end( argptr );
#endif

  idx = 0;
  for ( i=1; i<argc; i++ )
    if ( strcmp( argv[i], opt )==0 ){
      strcpy( buf, "" );
      idx = i;
      while ( ++i < argc ){
        strcat( buf, argv[i] );
        strcat( buf, " " );
      }
#ifdef ENABLE_VSSCANF
      va_start( argptr, key );
      vsscanf( buf, fmt, argptr );
      va_end( argptr );
#else
      sscanf( buf, fmt, VLIST10(val) );
#endif
      break;
    }
#ifndef ENABLE_VSSCANF
  free( val );
#undef VLIST10
#endif
  return idx;
  /*
   * following methods do not work in place of vsscanf
   *  sscanf ( buf, fmt, _va_ptr );
   *  sscanf ( buf, fmt, argptr  );
   *  vfscanf( buf, fmt, argptr  );
   */
}

#endif /* _OPTION_H_ */
