/*
 * Source File < graphics/page.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * standard functions for page as drawing device
 */
void cleardevice( void )
{
  XClearWindow( XBGI->dpy, XBGI->win[XBGI->apage] );
}
void setactivepage( int page )
{
  XBGI->apage = minmax( 0, page, XBGI->npage-1 );
}
void setvisualpage( int page )
{
  int i;

  if ( page >= XBGI->npage ){
    /* all pages full mapped mode */
    for ( i=0; i<XBGI->npage; i++ ){
      XReparentWindow( XBGI->dpy,
                      XBGI->win[i], RootWindow(XBGI->dpy,XBGI->scr), 0, 0 );
      XMapWindow( XBGI->dpy, XBGI->win[i] );
    }
    XUnmapWindow( XBGI->dpy, XBGI->root );
    XBGI->vpage = XBGI->npage;
  }else if ( XBGI->vpage >= XBGI->npage && page < XBGI->npage ){
    /* one page mapped mode */
    XUnmapSubwindows( XBGI->dpy, XBGI->root );
    for ( i=0; i<XBGI->npage; i++ )
      XReparentWindow( XBGI->dpy, XBGI->win[i], XBGI->root, 0, 0 );
    XBGI->vpage = minmax( 0, page, XBGI->npage-1 );
    XMapWindow( XBGI->dpy, XBGI->root );
    XMapRaised( XBGI->dpy, XBGI->win[XBGI->vpage] );
  }else{
    XBGI->vpage = minmax( 0, page, XBGI->npage-1 );
    XMapRaised( XBGI->dpy, XBGI->win[XBGI->vpage] );
  }
}
void restorecrtmode( void )
{
  NotSupported( "restorecrtmode()" );
}
