/*
 * Source File < graphics/palette.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * standard functions to get and set palette
 */
struct palettetype *getdefaultpalette( void )
{
  static struct palettetype def;
  int c;
  
  def.size = XBGI->palette.size;
  for ( c=0; c<def.size; c++ )
    def.colors[c] = c;
  return &def;
}
void getpalette( struct palettetype *palette )
{
  *palette = XBGI->palette;
}
int getpalettesize( void )
{
  return XBGI->palette.size;
}
void setallpalette( struct palettetype *palette )
{
  int c;

  XBGI->palette = *palette;
  for ( c=0; c<palette->size; c++ )
    setpalette( palette->colors[c], c ); 
}
void setpalette( int colornum, int color )
{
  XColor xcolor;
  unsigned short red, green, blue;
  
  switch( XBGI->gmode ){
  case BGIMONO:
  case BGISGRAY:
  case BGISCOLOR:
    break;
  case BGIGRAY:
  case BGICOLOR:
    colornum = minmax( 0, colornum, XBGI->palette.size-1 );
    color    = minmax( 0, color,    XBGI->palette.size-1 );
    XBGI->palette.colors[color] = (unsigned char)colornum;
    red   = XBGI->rgb[colornum].red;
    green = XBGI->rgb[colornum].green;
    blue  = XBGI->rgb[colornum].blue;
    xcolor.pixel = XBGI->pixels[color];
    xcolor.red   = red;
    xcolor.green = green;
    xcolor.blue  = blue;
    xcolor.flags = DoRed | DoGreen | DoBlue;
    XStoreColor( XBGI->dpy, XBGI->colormap, &xcolor );
    XFlush( XBGI->dpy );
    break;
  }
}
void setrgbpalette( int colornum, int red, int green, int blue )
{
  _setrgbpalette( colornum, 
                 minmax( 0, 65536*red  /XBGI->palette.size, 65536-1 ),
                 minmax( 0, 65536*green/XBGI->palette.size, 65536-1 ),
                 minmax( 0, 65536*blue /XBGI->palette.size, 65536-1 ) );
}
void _setrgbpalette( int colornum,
                    unsigned short red,
                    unsigned short green,
                    unsigned short blue )
{
  XColor xcolor;

  switch( XBGI->gmode ){
  case BGIMONO:
  case BGISGRAY:
    break;
  case BGISCOLOR:
    break;
  case BGIGRAY:
  case BGICOLOR:
    colornum = minmax( 0, colornum, XBGI->palette.size-1 );
    XBGI->rgb[colornum].red   = red;
    XBGI->rgb[colornum].green = green;
    XBGI->rgb[colornum].blue  = blue;
    xcolor.pixel = XBGI->pixels[colornum];
    xcolor.red   = XBGI->rgb[colornum].red;
    xcolor.green = XBGI->rgb[colornum].green;
    xcolor.blue  = XBGI->rgb[colornum].blue;
    xcolor.flags = DoRed | DoGreen | DoBlue;
    XStoreColor( XBGI->dpy, XBGI->colormap, &xcolor );
    XFlush( XBGI->dpy );
    break;
  }
}
