/*
 * Source File < graphics/text.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * standard function to out text on graphics
 */
void outtext( char *textstring )
{
  outtextxy( XBGI->cp.x, XBGI->cp.y, textstring );
  moverel( (XBGI->textset.direction==HORIZ_DIR)?textwidth(textstring):0,
          (XBGI->textset.direction==VERT_DIR)?textwidth(textstring):0 );
}
void outtextxy( int x, int y, char *textstring )
{
  int font = XBGI->textset.font;
  int dir  = XBGI->textset.direction;
  int size = XBGI->textset.charsize;
  int width = textwidth(textstring), height = textheight(textstring);
  int textx, texty;
  int i, j, k;
  Pixmap pixmap;
  XImage *image;
  unsigned char *data;
  GC gc;
  
  switch ( dir ){
  case VERT_DIR:
    /*
     * difficult vertical direction
     */
    pixmap = XCreatePixmap( XBGI->dpy, XBGI->win[XBGI->apage],
                           width, height, XBGI->depth );
    gc = XCreateGC( XBGI->dpy, pixmap, 0, 0 );
    XSetForeground( XBGI->dpy, gc, XBGI->pixels[XBGI->bkcolor] );
    XFillRectangle( XBGI->dpy, pixmap, gc, 0, 0, width, height );
    XSetForeground( XBGI->dpy, gc, XBGI->pixels[XBGI->color] );
    if ( XBGI->only_ascii || font != DEFAULT_FONT ){
      if ( XBGI->chr[font][size] != NULL )
        XSetFont( XBGI->dpy, gc, XBGI->chr[font][size]->fid );
      XDrawString( XBGI->dpy, pixmap, gc,
                  0, TextAscent(XBGI->chr[font][size]),
                  textstring, strlen(textstring) );
    }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
      if ( XBGI->chr[font][size] != NULL )
        XSetFont( XBGI->dpy, gc, XBGI->chr[font][size]->fid );
      XDrawString( XBGI->dpy, pixmap, gc,
                  0, TextAscent(XBGI->chr[font][size]),
                  textstring, strlen(textstring) );
#endif
#ifdef ENABLE_BILINGUAL
      XDrawBiString( XBGI->dpy, pixmap, gc,
                    XBGI->chr[font][size], XBGI->bchr0[size], 0,
                    max( TextAscent(XBGI->chr[font][size])
                        ,TextAscent(XBGI->bchr0[size]) ),
                    textstring, strlen(textstring) );
#endif
#ifdef ENABLE_MULTILINGUAL
      if ( XBGI->mchr0[size] ){
        XmbDrawString( XBGI->dpy, pixmap, XBGI->mchr0[size], gc, 0, 0,
                      textstring, strlen(textstring) );
      }else{
        XDrawString( XBGI->dpy, pixmap, gc,
                    0, 0, textstring, strlen(textstring) );
      }
#endif
    }
    if ( XBGI->only_ascii || font != DEFAULT_FONT ){
      switch( XBGI->textset.horiz ){
      case LEFT_TEXT:
        x += TextAscent( XBGI->chr[font][size] );
        break;
      case CENTER_TEXT:
        x += height/2;
        break;
      case RIGHT_TEXT:
        x -= TextDescent( XBGI->chr[font][size] );
        break;
      }
    }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
      switch( XBGI->textset.horiz ){
      case LEFT_TEXT:
        x += TextAscent( XBGI->chr[font][size] );
        break;
      case CENTER_TEXT:
        x += height/2;
        break;
      case RIGHT_TEXT:
        x -= TextDescent( XBGI->chr[font][size] );
        break;
      }
#endif
#ifdef ENABLE_BILINGUAL
      switch( XBGI->textset.horiz ){
      case LEFT_TEXT:
        x += max( TextAscent( XBGI->chr[font][size] )
                 ,TextAscent( XBGI->bchr0[size] ) );
        break;
      case CENTER_TEXT:
        x += height/2;
        break;
      case RIGHT_TEXT:
        x += max( TextDescent( XBGI->chr[font][size] )
                 ,TextDescent( XBGI->bchr0[size] ) );
        break;
      }
#endif
#ifdef ENABLE_MULTILINGUAL
      switch( XBGI->textset.horiz ){
      case TOP_TEXT:
        break;
      case CENTER_TEXT:
        x -= textheight(textstring)/2;
        break;
      case BOTTOM_TEXT:
        x -= textheight(textstring);
        break;
      }
#endif
    }
    switch( XBGI->textset.vert ){
    case TOP_TEXT:
      break;
    case CENTER_TEXT:
      y -= width/2;
      break;
    case BOTTOM_TEXT:
      y -= width;
      break;
    }
    image = XGetImage( XBGI->dpy, pixmap, 0, 0, width, height,
                      AllPlanes, ZPixmap );
    data = (unsigned char *)image->data;
    for ( i=0; i<height; i++ ){
      for ( k=j=0; j<image->bytes_per_line; j++, data++ ){
        if ( j<image->xoffset ) continue;
        k++;
        if ( width < k ) continue;
        if ( XBGI->colortable[*data] == XBGI->color )
          XDrawPoint( XBGI->dpy, XBGI->win[XBGI->apage], XBGI->gcdraw,
                     x + i, y + ( width - k ) );
      }
    }
    XDestroyImage( image );
    XFreeGC( XBGI->dpy, gc );
    XFreePixmap( XBGI->dpy, pixmap );
    break;
  case HORIZ_DIR:
    /*
     * horizontal direction
     */
    switch( XBGI->textset.horiz ){
    case LEFT_TEXT:
      break;
    case CENTER_TEXT:
      x -= textwidth(textstring)/2;
      break;
    case RIGHT_TEXT:
      x -= textwidth(textstring);
      break;
    }
    if ( XBGI->only_ascii || font != DEFAULT_FONT ){
      switch( XBGI->textset.vert ){
      case TOP_TEXT:
        y += TextAscent( XBGI->chr[font][size] );
        break;
      case CENTER_TEXT:
        y += height/2;
        break;
      case BOTTOM_TEXT:
        y -= TextDescent( XBGI->chr[font][size] );
        break;
      }
    }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
      switch( XBGI->textset.vert ){
      case TOP_TEXT:
        y += TextAscent( XBGI->chr[font][size] );
        break;
      case CENTER_TEXT:
        y += height/2;
        break;
      case BOTTOM_TEXT:
        y -= TextDescent( XBGI->chr[font][size] );
        break;
      }
#endif
#ifdef ENABLE_BILINGUAL
      switch( XBGI->textset.vert ){
      case TOP_TEXT:
        y += max( TextAscent( XBGI->chr[font][size] )
                 ,TextAscent( XBGI->bchr0[size] ) );
        break;
      case CENTER_TEXT:
        y += height/2;
        break;
      case BOTTOM_TEXT:
        y -= max( TextDescent( XBGI->chr[font][size] )
                 ,TextDescent( XBGI->bchr0[size] ) );
        break;
      }
#endif
#ifdef ENABLE_MULTILINGUAL
      switch( XBGI->textset.vert ){
      case TOP_TEXT:
        y += textheight(textstring);
        break;
      case CENTER_TEXT:
        y -= textheight(textstring)/2;
        break;
      case BOTTOM_TEXT:
        y -= textheight(textstring);
        break;
      }
#endif
    }
    if ( XBGI->only_ascii || font != DEFAULT_FONT ){
      XDrawString( XBGI->dpy, XBGI->win[XBGI->apage], XBGI->gcdraw,
                  Xx( x ), Xy( y ), textstring, strlen(textstring) );
    }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
      XDrawString( XBGI->dpy, XBGI->win[XBGI->apage], XBGI->gcdraw,
                  Xx( x ), Xy( y ), textstring, strlen(textstring) );
#endif
#ifdef ENABLE_BILINGUAL
      XDrawBiString( XBGI->dpy, XBGI->win[XBGI->apage], XBGI->gcdraw,
                    XBGI->chr[font][size], XBGI->bchr0[size],
                    Xx( x ), Xy( y ),
                    textstring, strlen(textstring) );
#endif
#ifdef ENABLE_MULTILINGUAL
      if ( XBGI->mchr0[size] ){
        XmbDrawString( XBGI->dpy, XBGI->win[XBGI->apage],
                      XBGI->mchr0[size], XBGI->gcdraw,
                      Xx( x ), Xy( y ), textstring, strlen(textstring) );
      }else{
        XDrawString( XBGI->dpy, XBGI->win[XBGI->apage], XBGI->gcdraw,
                    Xx( x ), Xy( y ),
                    textstring, strlen(textstring) );
      }
#endif
    }
    break;
  }
}
