/*
 * Source File < graphics/util.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * official enhanced function to save to x bitmap file
 */
int savegraphtoxbm( char *filename )
{
  Pixmap bitmap;
  GC gc;
  XImage *image;
  int i, j, k;
  int x, y, width, height;
  unsigned char *data;
  int status = !BitmapSuccess;

  if ( 0 <= XBGI->vpage && XBGI->vpage < XBGI->npage ){
    getgeometry( &x, &y, &width, &height );
    bitmap = XCreatePixmap( XBGI->dpy, XBGI->win[XBGI->vpage],
                           width, height, 1 );
    gc = XCreateGC( XBGI->dpy, bitmap, 0, 0 );
    XSetForeground( XBGI->dpy, gc, WhitePixel(XBGI->dpy,XBGI->scr) );
    XSetBackground( XBGI->dpy, gc, BlackPixel(XBGI->dpy,XBGI->scr) );
    XSetFillStyle( XBGI->dpy, gc, FillSolid );
    XFillRectangle( XBGI->dpy, bitmap, gc, 0, 0, width, height );
    XSetForeground( XBGI->dpy, gc, BlackPixel(XBGI->dpy,XBGI->scr) );
    XSetBackground( XBGI->dpy, gc, WhitePixel(XBGI->dpy,XBGI->scr) );
    image = XGetImage( XBGI->dpy, XBGI->win[XBGI->vpage],
                      0, 0, width, height, AllPlanes, ZPixmap );
    data = (unsigned char *)image->data;
    for ( i=0; i<height; i++ ){
      for ( k=j=0; j<image->bytes_per_line; j++, data++ ){
        if ( j<image->xoffset ) continue;
        k++;
        if ( width < k ) continue;
        if ( XBGI->colortable[*data] != XBGI->bkcolor )
          XDrawPoint( XBGI->dpy, bitmap, gc, k, i );
      }
    }
    XDestroyImage( image );
    status = XWriteBitmapFile( XBGI->dpy, filename, bitmap,
                              width, height, 0, 0 );
    XFreeGC( XBGI->dpy, gc );
    XFreePixmap( XBGI->dpy, bitmap );
  }
  return status == BitmapSuccess;
}
/*
 * official enhanced function to save to x pixmap file
 */
int savegraphtoxpm( char *filename )
{
  XImage *image;
  int i, j, k;
  int x, y, width, height;
  int status = !BitmapSuccess;

#ifdef ENABLE_XPMLIB
  if ( 0 <= XBGI->vpage && XBGI->vpage < XBGI->npage ){
    getgeometry( &x, &y, &width, &height );
    image = XGetImage( XBGI->dpy, XBGI->win[XBGI->vpage],
                      0, 0, width, height, AllPlanes, ZPixmap );
    status = XpmWriteFileFromImage( XBGI->dpy, filename, image, 0, NULL );
    XDestroyImage( image );
  }
#else
  status = !BitmapSuccess;
#endif
  return status == BitmapSuccess;
}
