/*
 * Source File < graphics/viewport.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * standard functions for viewport as virtual drawing device
 */
void clearviewport( void )
{
  if ( XBGI->viewport.clip )
    XClearArea( XBGI->dpy, XBGI->win[XBGI->apage],
               XBGI->viewport.left, XBGI->viewport.top, 
               XBGI->viewport.right - XBGI->viewport.left + 1,
               XBGI->viewport.bottom - XBGI->viewport.top + 1, False );
  else
    cleardevice();
}
void setviewport( int left, int top, int right, int bottom, int clip )
{
  XRectangle rec;

  XBGI->viewport.left   = min( left, right );
  XBGI->viewport.top    = min( top, bottom );
  XBGI->viewport.right  = max( left, right );
  XBGI->viewport.bottom = max( top, bottom );
  XBGI->viewport.clip   = clip;
  if ( XBGI->viewport.clip ){
    rec.x = XBGI->viewport.left;
    rec.y = XBGI->viewport.top;
    rec.width  = XBGI->viewport.right - XBGI->viewport.left + 1;
    rec.height = XBGI->viewport.bottom - XBGI->viewport.top + 1;
    XSetClipRectangles( XBGI->dpy, XBGI->gcdraw,  0, 0, &rec, 1, YXSorted );
    XSetClipRectangles( XBGI->dpy, XBGI->gcfill,  0, 0, &rec, 1, YXSorted );
    XSetClipRectangles( XBGI->dpy, XBGI->gcpixel, 0, 0, &rec, 1, YXSorted );
    XSetClipRectangles( XBGI->dpy, XBGI->gcimage, 0, 0, &rec, 1, YXSorted );
  }else{
    XSetClipMask( XBGI->dpy, XBGI->gcdraw,  None );
    XSetClipMask( XBGI->dpy, XBGI->gcfill,  None );
    XSetClipMask( XBGI->dpy, XBGI->gcpixel, None );
    XSetClipMask( XBGI->dpy, XBGI->gcimage, None );
  }
}
void getviewsettings( struct viewporttype *viewport )
{
  *viewport = XBGI->viewport;
}
